.binarymode ti8xapp                 ; TI-83+ Application

.deflong bjump(label)               ; Jump macro
   call BRT_JUMP0
   .dw label
.enddeflongw

.deflong bcall(label)               ; Call macro
   rst rBR_CALL
   .dw label
.enddeflong


.defpage 0, 16384, $4000          ; Page 0 definition
.page 0
.block 128
.nolist
#define    TASM
#define    bcall(xxxx)     rst 28h \ .dw xxxx
#define    equ .equ
#define    ProgStart    $4080
#define    LCDDelay()   .db $DB,$10,$87,$38,$FB
#include "BatLib.inc"
#include "FileSyst.inc"


.variablename "FileSyst"

.list
Start:
     jp MenuInstall
JumpTable:
CommandTable:
     .dw FileSystCode,IndicatorOff,TokSprite,DBRead,AnsType,Get2Key,BaseX
     .dw PopUpMenu,GetVar,GetStats
     .dw HexToken,TokenHex,GetKeyGroup,GetBytes,StoBytes,VarEditByte
     .dw VarReadByte,ASMHex,DPutSpriteCommand,VarType,BatteryLevel
     .dw IncContrast,DecContrast,Rectangle
     .dw SpeedyKeys,DisableKeyHooks,HexSprite,Draw,GetVersion,DelVar
     .dw CopyProg,RealToStr,ListToStr,Left,Right,Mid,ExecVarBASIC
     .dw GetProgName,DelElements,InsElements
     .dw InsertList,InsertBytes,StringWidth,ReplaceByte,NumStr,ListNumStr
     .dw CompressStr,DeCompStr,GetCodec,CompData,DeCompData,SearchReplace
     .dw GetName,Lowercase
     .dw DelLine,NewVar
CommandTableEnd:
SetUp:                          ;Start of the parser hook
        .db 83h                 ;83
HookCode:
        or a                    ; or a         tests if a is 0 and resets carry flag
        ret z                   ;C8
        push hl                 ; push hl         Number of arguments
        ld hl,$B5B5             ;21B5B5    B5 is the token for dim(
        sbc hl,bc               ;ED42      a way to compare hl to bc (we want to see if hlbc)
        pop hl                  ;\ pop hl 
        ld (TempWord1),a
        jr nz,ExitHook
;
;Step one complete... The hook only gets this far if the dim(
;token needs to be parsed...
;
;Set to 15MHz, saveSP
        in a,(2)                ;DB02        use to get the model
        rrca                    ;07          to put bit 7 in bit 0
        and 1                   ;E601        masks out all bits except bit 0. This tells if the model can use 15MHz
        out (20h),a             ;D320        if a is 1, sets to 15MHz, if a is 0, sets 6MHz.
        di
        ld (SPSave),sp
;Check FirstArgument
        ld a,l
        dec a
        or h
        jr nz,ExitHook+5
          ld a,(OP1)
          and 1Fh
          dec a           ;list
          jr z,ExitHook
          dec a           ;matrix
          jr z,ExitHook
          sub 11          ;complex list
          jr nz,$+7
ExitHook:
        cp a
        ld a,(TempWord1)
        ret
;If it makes it this far, it is a BatLib command
        ld (ArgCount),hl        ;22****
        push hl                 ; push hl
        rst 18h                 ;DF          
        rst 08h                 ;CF          
        pop hl                  ;\ pop hl     
        bcall(439Fh)            ;EF9F43      
        ld hl,(9824h)           ;2A2498      9842h FPS (FPSFloating Point Stack)
        ld (ArgLoc),hl          ;22****
        xor a                   ;AF          Set A to 0
        ld (8A11h),a            ;32118A      Reset all the BatLib flags
     ld hl,RamCode
     ld de,RamLoc
     ld bc,RamCodeEnd-RamCode
     ldir
     in a,(6)
     ld (AppPage),a

CommandStart:
     ld hl,(ArgLoc)
     ld a,(hl)
     cp 4
     jr z,FileSystCommand       
     call LoadInc
     jp z,HardExit
     ld hl,CommandStart
     push hl
BatCommand:
       ld hl,CommandTable
       ld bc,(CommandTableEnd-CommandTable)/2
       ex de,hl
       or a
       sbc hl,bc
       add hl,bc
       jp nc,DispGraphBuffer
       add hl,hl
       add hl,de
       ld d,(hl)
       inc hl
       ld h,(hl)
       ld l,d
       jp (hl)
FileSystCode:
;     ld hl,(ArgCount)
;     ld a,h \ or l
;     jr z,$+11
;       ld hl,(ArgLoc)
;       ld a,(hl)
;       cp 4
;       call z,OpenFileSystPath
     ld hl,(965Fh)
     ld de,(965Dh)
     inc de
     or a
     sbc hl,de
     ld b,h
     ld c,l
     ld h,d
     ld l,e
     ld a,$D5        ;Return token
     cpir
     ld (965Dh),hl
;DE points to start
     sbc hl,de
     ret z
     push de
     bcall(4324h)
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     pop de
     push hl
     push bc
     ex de,hl
     ldir
     pop bc
     pop hl
     jr BatJumpIn 
FileSystCommand:
     ld hl,(ArgCount)
     ld a,h
     or l
     jp z,HardExit
     call LocateStr     ;DE points to data, BC is size
     ex de,hl
BatJumpIn:
     ld (StrPtr),hl
     call DeTokFSStr
;Locate the WorkingDirectory variable
;=======================
     call LoadWD
     ld hl,FSVar
     rst 20h
     call FindSym
     jr nc,$+10
     ld a,31
     ld hl,0
     bcall(_CreateVar)
     call FSStart
     jp HardExit
FSStart:
     ld (FSLoc),de
;     xor a
;     ld (DirNest),a
;     ld h,a
;     ld l,a
;     ld (DirBuf),hl
     di
     bcall(_OP2Set1)
     ld hl,(StrPtr)
     ld bc,(StrSize)
ParseStr:
     ex de,hl
     call LookUpCMD
     ld bc,(StrSize)
     ld hl,(StrPtr)
Is_Finished:
     ld a,b
     or c
     ret z
     cpi
     ret po
NextCommandLoop:
     ld a,(hl)
     cp 4
     jr z,StoToStr
     cp 3Fh
     jr z,$+4
     ld a,29h
     cpi
     jr z,NextCommandLoop
     ret po
     inc bc
     dec hl
     ld (StrSize),bc
     ld (StrLoc),hl
     jr nz,ParseStr
StoToStr:
     cpi
     dec bc
     push bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     ld (SCSaveStrLoc),hl
     push bc
     call COP2ToOP1
;     rst 18h                ;rPushRealO1
     bcall(_ChkFindSym)
     cp 4
     jr nz,StrCopied
     ex de,hl
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld (TempAddr),hl
     pop bc
     push de
     ld (OP1+1),bc
     call SearchVarBC
     jr c,$+5
     bcall(_DelVarArc)
     pop hl
     push hl
     bcall(4327h)
     pop bc
     ld hl,(TempAddr)
     inc de
     inc de
     ldir
StrCopied:
;     bcall(438Dh)      ;PopRealO2
     ld hl,(SCSaveStrLoc)
     pop bc
     jp Is_Finished
LookUpCMD:
     ld hl,FS_LUT
     ld b,0
LUTLoop:
     ld a,(de)
     ld c,(hl)
     inc hl
     cpi
     jr z,RestOfWord
     add hl,bc
     inc hl
     inc hl
     ld a,(hl)
     or a
     jr nz,LUTLoop
ErrFuncNotFound:
     ld hl,FuncNotFoundStr1
     jp Error
RestOfWord:
     ld (cmdSize),bc
     ex af,af'
     xor a
     ex af,af'
     jp po,Special
LUTLoop1:
     inc de
     ld (StrPtr),de
     ex af,af'
     inc a
     ex af,af'
     ld (LastMatch),a
LUTLoop2:
     ld a,(de)
     cpi
     jp po,$+7
     jr z,LUTLoop1
     jr NoMatch
     cp 16
     jr z,FoundFunc
NoMatch:
     add hl,bc
     inc hl
     inc hl
     ld c,(hl)
     dec c
     ld (cmdsize),bc
     inc c
     ex af,af'
     push bc
     ld c,a
     add hl,bc
     pop bc
     ld b,a
     ex af,af'
     ld a,c
     sub b
     ld c,a
     ex af,af'
     ld b,a
     ld a,(LastMatch)
     cp (hl)
     jr nz,ErrFuncNotFound
     inc hl
     ld a,b
     ex af,af'
     ld b,0
     ld de,(StrPtr)
     jr nc,LUTLoop2
     dec b
     jr NoMatch
Special:
     cp 16
     jr nz,ErrFuncNotFound
FoundFunc:
     ld a,(hl)
     inc hl
     ld h,(hl)
     ld l,a
     push hl
     inc de
     ld hl,(StrSize)
     ld (StrPtr),de
     ld bc,(cmdSize)
     scf
     sbc hl,bc
     ld (StrSize),hl
     ret
funcCOMP:
funcMOVE:
funcSCUT:
     ld hl,(StrSize)
     ld bc,(StrLoc)
     ld a,11h
     cpir
     ld (StrSize),hl
     ld (StrLoc),bc
     ret
funcRFA:
;Remove File Association
;Edits Field 0
     call FindInputFA
     ret nz           ;Means association doesn't exist
     inc hl
     inc hl
     ld (TempWord2),hl
     inc c \ sub c \ ld l,a
     sbc a,a \ sub b \ ld h,a
     ld bc,0
     call EditField
;need to check if final field size is 1, if so, delete the whole field
     ld hl,(TempWord2)
     dec hl
     ld d,(hl)
     dec hl
     ld e,(hl)
     ld a,e
     dec a \ or d
     ret nz
     jp FDeljr
funcAFA:
     call FindInputFA
     ret z            ;means association exists
;     pop bc
     push hl
     inc hl
     inc hl
     ex de,hl
     ld h,b
     ld l,c
     inc hl
     call EditField-4
     xor a
     ld (de),a
     pop hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     add hl,bc
     ld (hl),a
     ret
funcCF:
;     CF(path,field#[,data)
     call OpenFolder
     ret c
     jr nz,$+9
       ld a,(NestDepth)
       dec a
       ld (NestDepth),a     
     push de
     call ConvRStr8
     ld a,e
     push af
     call InputStrInfo
     ld (TempAddr),hl
     pop af
     pop hl
     push de
;(TempAddr) points to the new field data
;DE is the size of the new field data
;A is the field#
;HL points to the file header
     call FindField
     ld (TempWord1),de
     ccf
     call nc,MakeFieldSub
     pop de
     push de      ;size of the new field
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ex de,hl
     or a
     sbc hl,bc
     pop bc
     ld (TempWord2),de
EditField:
;     (TempWord1) points to fields start
;     (TempWord2) points to the field data
;     BC is how many bytes will be copied
;     HL is the number of bytes to insert
;     DE is the location to insert at
;     (TempAddr) is the location of the string to insert
     push bc       ;how many bytes get copied
     push de       ;location to insert
     push hl       ;number of bytes to insert
     call InsertMem
     ld hl,(TempWord2)
     pop bc        ;value to add to size
     dec hl
     ld d,(hl)
     dec hl
     ld e,(hl)
     ex de,hl
     add hl,bc
     ex de,hl
     ld (hl),e
     inc hl
     ld (hl),d
     call ResizeFields
     pop de
     pop bc
     ld hl,(TempAddr)
     ld a,b
     or c
     jr z,DeleteField
     ldir
     ret
funcFDEL:
;     FDEL(path,field#)
     call OpenFolder
     ret c
     push de
     call ConvRStr8
     ld a,e
     pop hl
     call FindField
     ret c
     ld (TempWord1),de
     ld e,(hl)
     inc hl
     ld d,(hl)
     dec hl
     jr FDeljr
DeleteField:
;(TempWord2) points to the field data
;Delete the field if zero sized
     ld hl,(TempWord2)
     dec hl
     ld d,(hl)
     dec hl
     ld e,(hl)
     ld a,d
     or e
     ret nz
FDeljr:
     dec hl
     inc de
     inc de
     inc de
     xor a \ sub e \ ld e,a
     sbc a,a \ sub d \ ld d,a
     ex de,hl
     push hl
     call InsertMem
     pop bc
     call ResizeFields
     ld a,d
     or a
     ret nz
     or e
     dec a
     dec a
     ret nz
     ld hl,-2
     ld de,(TempWord1)
     xor a
     ld (de),a
     inc de
     jp InsertMem


ResizeFields:
;Inputs:
;     BC is the number of bytes to add
;     (TempWord1) points to the fields size bytes
;Output:
;     HL points to the ending size bytes of the fields
;     DE is the size of the fields data
;     BC is not affected
;     A is not affected
     ld hl,(TempWord1)
     ld e,(hl)
     inc hl
     ld d,(hl)
     ex de,hl
     add hl,bc
     ex de,hl
     ld (hl),d
     dec hl
     ld (hl),e
     add hl,de
     ld (hl),e
     inc hl
     ld (hl),d
     ret
funcCFT:
;Change File Type
     call OpenFolder
     ret c
     push de
     call ConvRStr8
     pop hl
     ld (hl),e
     ret
funcCOPY:
     call OpenFolder
     push af
     ld (TempAddr),hl
     ld hl,(StrLoc)
     ld a,2Bh
     cp (hl)
     jr nz,$+13
       inc hl
       ld (StrLoc),hl
       ld hl,(StrSize)
       dec hl
       ld (StrSize),hl
     call OpenFolder
     jr z,CopyToFold
     pop af
     jp z,ErrNotAFile    ;can't copy folders to files
;file to file
     jr CopyToVar
CopyToFold:
     pop af
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld (TempWord1),hl
     ld (TempWord2),bc
     ld hl,(TempAddr)
     call FindFileStart+5
     ex de,hl
     ld b,(hl)
     inc hl
     ld c,(hl)
     inc hl
     call SearchFileName
CopyToVar:
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
;BC is the size of the new file
;     push hl
;BC+(HL-DE) to get size of the heder+data
     or a
     sbc hl,de
     add hl,bc
     push de
     push hl
;DE points to the data start of the new var header
;HL is the size of the new var
     ld hl,(TempAddr)
     call FindFileStart+5
     ld (TempAddr),de
     ld c,(hl) \ inc hl
     ld b,(hl) \ inc hl
     or a
     sbc hl,de
     add hl,bc
     pop bc
     pop de
;HL is the size of the old file
;DE point to the new file header
;BC is the size of the new file plus header
     push hl     ;number of bytes to copy
     or a
     sbc hl,bc   ;number of bytes to insert
     push de     ;where to insert
     call InsertMem
     pop de
     pop bc
     ld hl,(TempAddr)
     ldir
     ret
funcPWD:
     ld a,(DirNest)
     or a
     jp z,NDStr
     ld bc,-1
     ld hl,DirBuf+2
PWDPass1:
     inc bc
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     push hl
     push af
     ex de,hl
     push bc
     call FindFileStart
     pop bc
     ex de,hl
     call AddNameSizeToBC
     ;Get name size
     pop af
     pop hl
     dec a
     jr nz,PWDPass1
;BC is the size of the string to create
     call MakeAnsStrX
;BC is the size
;DE points to the data bytes
     ld h,d
     ld l,e
     add hl,bc
     ld b,h
     ld c,l
;BC points to the end of the file
     ld hl,DirBuf+2
PWDPass2:
     push bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     push hl
     push de
     ld h,b
     ld l,c
     call FindFileStart
     ex de,hl
     inc hl
     ld c,(hl)
     ld b,0
     inc hl
     pop de
     call ConvToTok
     pop hl
     pop bc
     ex de,hl
     or a
     sbc hl,bc
     add hl,bc
     ret z
     ex de,hl
     ld a,3Eh
     ld (de),a
     inc de
     jp PWDPass2
funcLOCK:
     ld c,2
     jr EditInfo
funcHIDE:
     ld c,1
EditInfo:
     ld b,0
     ld hl,(StrLoc)
     ld a,(hl)
     cp 71h
     jr nz,$+14
       inc b
       inc hl
       ld (StrLoc),hl
       ld hl,(StrSize)
       dec hl
       ld (StrSize),hl
     push bc
     call OpenFolder
     ex de,hl
     pop de
     ret c
     call SkipToInfo
     dec d
     jr nz,$+7
       ld a,e
       cpl
       and (hl)
       ld (hl),a
       ret
     ld a,e
     or (hl)
     ld (hl),a
     ret
funcCN:
     call OpenFolder
     ret c
     jr nz,$+9
       ld a,(NestDepth)
       dec a
       ld (NestDepth),a
     inc de
     push de
     call InputStrInfo
     ld a,e
     ld (TempAddr),hl
     pop hl
;Stack points to the new string
;HL points to the name size bytes
;A is the new size
     ld e,(hl)
     ld (hl),a
     push af
     ld d,0
     sub e
     jr nc,$+3
       dec d
     inc hl
     ex de,hl
     ld l,a
     push de
;HL is the number of bytes to insert
;DE is where to insert
;pop af for size of field
     call InsertMem
     pop de
     pop af
     or a
     ret z
     ld c,a
     ld b,0
     ld hl,(TempAddr)
     ldir
     ret
funcDEL:
     call OpenFolder
     jr nc,NDelAll
       ld hl,(FSLoc)
       ld e,(hl)
       inc hl
       ld d,(hl)
       inc hl
       xor a \ sub e \ ld e,a
       sbc a,a \ sub d \ ld d,a
       ex de,hl
       jp InsertMem
NDelAll:
     jr nz,$+6
       ld hl,NestDepth
       dec (hl)
     push de
     ex de,hl
     inc hl
     ld c,(hl)
     ld b,0
     add hl,bc
     inc hl
     ld a,(hl)
     inc a
     jr nz,$+8
       ld de,33
       call AddDEToHL_BC
     inc hl
     inc hl          ;points to size
     call AHLTHLBC
     call AHLTHLBC
     pop de
     ld hl,-8
     or a
     sbc hl,bc
     jp InsertMem
AHLTHLBC:
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
AddDEToHL_BC:
     add hl,de
     ex de,hl
     add hl,bc
     ld b,h
     ld c,l
     ex de,hl
     ret
funcGETD:
;Data is returned as:
;     :Type+Name                       ;n+1 bytes
;     :Info(binary flags)+Size         ;12 bytes
;     +2 bytes for the newlines
     call OpenFolder
     jp nz,ErrNotAFolder
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld a,d
     or e
     jr nz,$+7
NDStr:
       ld c,1
       jp NO_DATA+2
     ld (TempAddr),hl
     ld bc,0
GETDPass1:
     ld a,c
     add a,15
     ld c,a
     jr nc,$+3
     inc b
     call AddNameSizeToBC
     push bc
     ld a,(hl)
     inc a
     jr nz,$+9
       ld bc,33
       add hl,bc
       ex de,hl
       add hl,bc
       ex de,hl
     inc hl \ dec de    ;HL points to info
     inc hl \ dec de    ;HL points Field
     call SkipData
     call SkipData
     pop bc
     jp m,ErrFatal
     jr nz,GetDPass1
;BC is now the size of the var to create

     call MakeAnsStrX
     ld h,d
     ld l,e
     add hl,bc
     ld b,h
     ld c,l
     ld hl,(TempAddr)
;BC points to the end of the var
;DE points to the data bytes
;HL points to the folder data
     
GETDPass2:
     push bc
     ldi
     ld c,(hl)
     inc hl
     ld b,0
     call ConvToTok
     ld a,3Eh
     ld (de),a
     inc de
     ld a,(hl)
     inc a
     jr nz,$+5
       ld c,33
       add hl,bc
     inc hl
     ld b,8
       ld a,18h
       rlc (hl)
       adc a,a
       ld (de),a
       inc de
       djnz $-7
     inc hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     add hl,bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     add hl,bc
     ld a,b
     call HexAToDE
     call HexAToDE
     ld a,c
     call HexAToDE
     call HexAToDE
     ld a,3Eh
     ld (de),a
     inc de
;HL points to the next file
     pop bc
     ex de,hl
     or a
     sbc hl,bc
     add hl,bc
     ex de,hl
     jr nz,GETDPass2
     ret
HexAToDE:
     rlca
     rlca
     rlca
     rlca
     push af
     and 15
     cp 10
     jr c,$+4
     add a,7
     add a,30h
     ld (de),a
     inc de
     pop af
     ret
funcCD:
     call OpenFolder
SetTPathAsMain:
     ld a,(NestDepth)
     ld (DirNest),a
     inc a
     add a,a
     ld c,a
     ld b,0
     ld hl,FileBuf
     ld de,DirBuf
     ldir
     ret
funcGICON:
     call OpenFolder
     ld a,(de)
     ex de,hl
     inc hl
     ld d,0
     ld e,(hl)
     inc e
     add hl,de
     ld e,(hl)
     inc e
     inc hl          ;HL points to the data if custom
     jr z,LoadIcon
       dec e
       jr nz,EIsIcon
         cp 1Fh
         jr z,EIsIcon-2
         or a
         jr z,EIsIcon-1
         jr EIsIcon+1
         inc e
         inc e
EIsIcon:
       dec e
       ex de,hl
       add hl,hl
       add hl,hl
       add hl,hl
       add hl,hl
       add hl,hl
       ld de,Icons
       add hl,de
LoadIcon:
     push  hl
     ld hl,32
     call MakeAnsStrHL+5
     pop hl
     ldir
     ret
funcCI:
     call OpenFolder
     ex de,hl
     inc hl
     ld c,(hl)
     inc c
     ld b,0
     add hl,bc       ;hl points to the Icon byte
     push hl
     call ConvRStr8  ;e is the 1-byte value
     pop hl
     ld c,(hl)
     ld (hl),e
     xor a
     ld d,a
     inc e
     push af
     jr nz,$+4
       add a,33
     inc c
     jr nz,$+7
       sub 33
       jr nc,$+3
         dec d
     ld e,a
     inc hl
     push hl
     ex de,hl
     call InsertMem
     pop hl
     pop af
     ret nz
;If it made it this far, there are 32 bytes that must be copied as a custom icon
     ex de,hl
     ld hl,(StrLoc)
     ld bc,(StrSize)
     cpi
     ret po
     ex de,hl
     push hl
     ld a,32
CopyIconLoop:
       push af
       call LoadHexAtDE
       jr c,$+5
       xor a \ rld
       call c,LoadHexAtDE
       inc hl
       jr nc,$+8
       pop af
       dec a
       jr nz,CopyIconLoop
       jr $+3
     pop af
     ld (StrLoc),de
     ld (StrSize),bc
     pop hl
     ld bc,32
     add hl,bc
     ld (hl),-1
     ret     
funcBASIC:
     call OpenFolder
     ex de,hl
     call SkipToInfo
     ex de,hl
     ld a,(de)
     bit 3,a
     jr z,$+7
       call OpenShortCut     ;Input: HL points to size bytes of shortcut
       jr funcBASIC+3
     rlca
     jr nc,ExecVarAtHL
       ld c,(hl)
       inc hl
       ld b,(hl)
       inc hl
       ld de,OP1
       ldir
       xor a
       ld (de),a
       bcall(_ChkFindSym)
       jp c,ErrVarNotFound
       ex de,hl
       ld a,b
       or a
       jr z,$+17
         ld b,0
         add hl,bc
         ld c,10
         add hl,bc
         bit 7,h
         jr z,$+3
         inc a
         res 7,h
         set 6,h        
ExecVarAtHL:
     push hl
     push af        ;flash page saving
     ld hl,TempName2
     rst 20h
     bcall(_ChkFindSym)
     jr c,$+5
     bcall(_DelVarArc)
     pop af
     pop hl
     call ExecProgAtAHL
     bcall(_OP2Set1)
     ret
funcVPTR:
     call OSVarName
     ld b,0
     inc c
     push bc
     call OpenFolder     ;Must create folders/files if they don't exist
;HL points to the size bytes
;DE points Type byte
     ex de,hl
     call SkipToInfo
     set 7,(hl)   
     ex de,hl
     pop de
;DE is new size,
;HL points to the size bytes
     push de
     push hl
     call ResizeFile
     pop de
     pop bc
     ld hl,OP1
     inc de
     inc de
     ldir
     ret


;
;These are the commands...
;
IndicatorOff:
     ld hl,(ArgLoc)
     ld bc,-7
     add hl,bc
     ld a,(hl)
     and 15                 ;and $F0 if command 0
     jr nz,$+10
       bcall(4570h)         ;RunIndicatorOff
       res 5,(iy+0)         ;FDCB00AEC9
       ret
     dec a                  ;1-Done off
     jr z,$-6
     dec a                  ;2-Indicator off
     jr nz,$+6
       bcall(4570h)
       ret
     dec a                  ;3-Indicator on
     jr nz,$+6
       bcall(456Dh)
       ret
     dec a                  ;4-Done on
     ret nz
     set 5,(iy+0)
     ret
HexToken:
       call LocateStr
       ld h,d
       ld l,e
       srl b
       rr c
       push bc
       dec hl
       ld (hl),b
       dec hl
       ld (hl),c
       inc hl
       inc hl
       call HexTok
       pop de
       bcall(4357h)
       ret
TokenHex:
       call LocateStr
       ex de,hl
       dec hl
       dec hl
       ld e,(hl)
       sla (hl)
       inc hl
       ld d,(hl)
       rl (hl)
       inc hl
       add hl,de
       ex de,hl
       push hl
       bcall(42F7h)
       pop hl
       ld b,h
       ld c,l
       add hl,de
       ex de,hl
       dec hl
       dec de
TokHex:
       call GetTokAtHL
       call GetTokAtHL
       cpd
       jp pe,TokHex
       ret
GetTokAtHL:
     ld a,30h
     rrd
     cp 3Ah
     jr c,$+4
     add a,7
     ld (de),a
     dec de
     ret
HexTok:
       call GetHexAtDE
       call GetHexAtDE
       cpi
       jp pe,HexTok
       ret
GetHexAtDE:
     ld a,(de)
     cp 3Ah
     jr c,$+4
     sub 7
     inc de
     rld
     ret
HL_Times_A:
     ex de,hl
DE_Times_A:
     ld b,8
     ld hl,0
       add hl,hl
       rlca
       jr nc,$+3
         add hl,de
       djnz $-5
     ret
LoadInc:
LoadIncrement:
     ld de,(ArgLoc)
     ld a,(de)
     and 31
     jr z,$+5
       xor a
       jr $+9
     ld hl,(ArgCount)
     ld a,h
     cp l
     jr nz,$+5
       ld d,a
       ld e,a
       ret
     dec hl
     ld (ArgCount),hl
     ex de,hl
     call ConvDecAtHL
     ld (ArgLoc),hl
     or 1
     ld a,e
     ret
Conv_OP1:
     ld hl,8478h
ConvDecAtHL:
;Inputs:
;     HL points to the FP number to convert
;Outputs:
;      A is the 8-bit result
;      B is 0
;      C is the value of the last digit
;     DE is the 16-bit result
;     HL is incremented by 9
;Destroys:
     ex de,hl
     ld hl,9
     add hl,de
     push hl
     ex de,hl
     ld a,(hl)
     and 80h
     push af
     inc hl
     ld a,(hl)
     sub 80h
     ld de,0
     jr nc,$+17
       ld c,e
       ld b,e
ConvDone:
       pop af
       jr z,$+9
         ld a,e \ cpl \ ld e,a
         ld a,d \ cpl \ ld d,a
         inc de
       pop hl
       ld a,e
       ret
     ld b,a
     inc b
     inc hl
     ld a,(hl)
ConvDecLoop:
     rlca
     rlca
     rlca
     rlca
     push hl
     ld h,d
     ld l,e
     add hl,hl
     add hl,hl
     add hl,de
     add hl,hl
     ex de,hl
     pop hl
     and 15
     add a,e
     ld e,a
     jr nc,$+3
     inc d
     dec b
     jr z,ConvDone
     ld a,80h
     xor b
     jr z,ConvDone
     ld b,a
     ld a,(hl)
     jp m,ConvDecLoop+4
     inc hl
     jp ConvDecLoop-1
SetXXXAns:
       ld l,a
       ld h,0
SetXXXXAns:
       bcall(4792h)
       set 0,(iy+7)
       ret

GetKeyGroup:
       in a,(20h)
       push af
       xor a
       out (20h),a
       call LoadInc
       and 7Fh
       jp z,BAD_NUMBER
       cpl
       ld b,a
       xor a
         dec a
         out (1),a
         ld a,b
         out (1),a
         in a,(1)
         cpl
         bit 7,e
         jr nz,$+5
           or a
           jr z,$-14
       ld b,a
       pop af
       out (20h),a
       ld a,b
       jp SetXXXAns
GetBytes:
       call LoadInc
       push de
       call FindVarNameArc
       pop de
       add hl,de
       call CorrectOffset
       push hl
       push af
       call LoadInc
       ex de,hl
       call MakeAnsStrHL
       pop af
       pop hl
       jp ReadArc
StoBytes:
       call LoadInc
       push de
       call FindVarNameArc
       pop de
       add hl,de
       or a
       jp nz,ARCH
       push hl
       call LocateStr
       pop hl
SwapBytes:
       ld a,(de)
       ldi
       dec hl
       ld (hl),a
       inc hl
       jp pe,SwapBytes
       ret
VarEditByte:
     call CheckDigit3
       call FindVarNameArc
       or a
       jp nz,ARCH
       push hl
       call LoadInc
       pop hl
       add hl,de
       push hl
       call LoadInc
       pop hl
       ld c,(hl)
       ld (hl),e
       ld b,0
     bit 1,(iy+33)
     jr z,$+5
       inc hl
       ld b,(hl)
       ld (hl),d
     ld h,b \ ld l,c
     jp SetXXXXAns
CheckDigit3:
     res 1,(iy+33)
     ld hl,(ArgLoc)
     ld bc,-6
     add hl,bc
     ld a,(hl)
     and $F0
     jr z,$+6
     set 1,(iy+33)
     ret
VarReadByte:
     call CheckDigit3
       call FindVarNameArc
       push af
       push hl
       call LoadInc
       pop hl
       add hl,de
       pop af
       ld bc,2
       ld de,TempWord1
       push de
       call ReadArc
       pop hl
       ld e,(hl)
       ld d,b
       bit 1,(iy+33)
       jr z,$+4
         inc hl
         ld d,(hl)
       ex de,hl
       jp SetXXXXAns
FindvarNameArc:
;Returns:
;DE points to type
;BC is size
;HL points to data
;A is the page the data is on
     call LoadTypevarName
GetStatsArc:
     jp c,BAD_NAME
     ex de,hl
     or a
     jr nz,$+7
       ld c,(hl)
       inc hl
       ld b,(hl)
       inc hl
       ret
     add hl,bc
     ld c,10
     add hl,bc
     ld b,a
     ld a,h
     add a,a
     jr nz,$+5
       inc b
       ld h,40h
     ld a,b
     jp GetStatsArcCode
GetVar:
       call FindVarNameArc
       push af
       push hl
       call MakeAnsStrX
       pop hl
       pop af
       jp ReadArc
ASMHex:
       call LocateStr
       srl b
       rr c
       ld hl,86ECh
       push hl
       call HexTok
       ld (hl),$C9
       ret
DPutSpriteCommand:
       call LoadInc
       or a
       jp z,WIDTH
       push af
       call LoadInc
       or a
       jp z,HEIGHT
       push af
       call LoadInc
       and 3Fh
       push af
       call LoadInc
       and 0Fh
       push af
       call LocateStr
       pop hl
       pop af
       ld l,a
       pop bc
       pop af
       ld c,a
       call ConvDSprite
DputSprite:
;
;This needs to be optimised sometime...
;
        in a,(16)
        add a,a
        jr c,$-3
       ld a,32
       add a,h
       out (16),a
        in a,(16)
        add a,a
        jr c,$-3
       ld a,128
       add a,l
       out (16),a
       push bc
       push hl
          in a,(16)
          add a,a
          jr c,$-3
         ld a,(de)
         inc de
         out (17),a
         djnz $-9
       pop hl
       pop bc
       dec c
       inc h
       ld a,c
       or a
       jr nz,$-39
       ret
VarType:
       call LoadInc
       push af
       call FindVarNameArc
       pop af
       ld (de),a
       ret
BatteryLevel:
       bcall(4C6Fh)
       cp 1
       jr c,$+14
         ld a,b
         cp 30
         jr c,$+9
           bcall(5221h)
           bcall(478Fh)
           ret
       bcall(41BCh)
       bcall(50B3h)
       ret z
       bcall(4195h)
       ret
IncContrast:
       ld hl,8447h
       ld a,(hl)
       add a,$D9
       ret c
       inc (hl)
       dec a
       out (16),a
       ret
DecContrast:
       ld hl,8447h
       ld a,(hl)
       or a
       ret z
       dec (hl)
       add a,$D7
       out (16),a
       ret
Rectangle:
       ld hl,9340h
       push hl

; jr $
     call LoadInc
     push de
     call LoadInc
     pop de
     ld d,a
     push de
     call LoadInc
     push de
     call LoadInc
     pop de
     ld d,a
     push de
     call LoadInc
     pop bc
     pop de
     pop hl
     jr DrawRect
DrawRectToGraph:
     ld hl,9340h
;===============================================================
DrawRectToBuffer:
DrawRect:
;===============================================================
;Inputs:
;     A is the type of rectangle to draw
;        0 =White
;        1 =Black
;        2 =XOR
;        3 =Black border
;        4 =White border
;        5 =XOR border
;        6 =Black border, white inside
;        7 =Black border, XOR inside
;        8 =White border, black inside
;        9 =White border, XOR inside
;        10=Shift Up
;        11=Shift Down
;     B is the height
;     C is the Y pixel coordinate
;     D is the width in pixels
;     E is is the X pixel coordinate
;===============================================================
     di
     push hl
     pop ix
     ex af,af'
;Check if coords are negative
     ld a,c
     or a
     jp p,$+9
       add a,b
       ret nc
       ret z
       ld b,a
       ld c,0

     ld a,e
     or a
     jp p,$+9
       add a,d
       ret nc
       ret z
       ld d,a
       ld e,0
;Check dimensions
     ld a,b
     or a
     ret z
     jp p,$+6
       neg
       ld b,a
     add a,c
     sub 64
     jr c,$+6
       neg
       add a,b
       ld b,a

     ld a,d
     or a
     ret z
     jp p,$+6
       neg
       ld d,a
     add a,e
     sub 96
     jr c,$+6
       neg
       add a,d
       ld d,a
     ld a,c
     cp 64
     ret nc
     ld a,e
     cp 96
     ret nc
MakePattern:
     push bc
     ld hl,RectData
     ld b,24
     xor a
     ld (hl),a
     inc l
     djnz $-2
     ld hl,RectData
     ld c,RectData+12
     ld a,e
     sub 8
     jr c,$+6
       inc l
       inc c
       jr $-6
     add a,8
     ld e,a
     ld b,a
     inc b
     ld a,d
     add a,e
     ld e,a
     ld a,1
     rrca
     djnz $-1
     ld b,l
     push af
     ld l,c
     or (hl)
     ld (hl),a
     ld l,b
     pop af
     dec a
     scf
     adc a,a
     ld (hl),a
     ld a,e
     sub 8
     jr c,$+10
     jr z,$+10
       inc l
       ld (hl),-1
       inc c
       jr $-10
     add a,8

     ld b,a
     or a
     ld a,1
     jr z,$+5
     rrca
     djnz $-1

     ld b,l
     push af
     ld l,c
     or (hl)
     ld (hl),a
     ld l,b
     pop af
     dec a
     cpl
     and (hl)
     ld (hl),a
     pop bc
     ld a,b
     ld b,0
     ld h,b
     ld l,c
     add hl,hl
     add hl,bc
     add hl,hl
     add hl,hl
     push ix
     pop bc
     add hl,bc
     ld b,a
     ex af,af'
     .db $CB,$67,$28,$10,$D6,$10,$F5,$0E,$18,$11
     .dw RectData
     .db $1A,$2F,$12,$13,$0D,$20,$F9,$F1

     or a
     jr nz,$+13h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$2F,$A6,$77,$13,$23,$0D,$20,$F7,$10,$F0,$C9

     dec a
     jr nz,$+12h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$F1,$C9

     dec a
     jr nz,$+12h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23
     .db $0D,$20,$F8,$10,$F1,$C9

     dec a
     jr nz,$+26h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$05,$C8
     .db $05,$28,$0F,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$F1,$04,$18,$DC

     dec a
     jr nz,$+28h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$10,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$10,$F0,$04,$18,$DA

     dec a
     jr nz,$+26h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE
     .db $77,$13,$23,$0D,$20,$F8,$05,$C8,$05,$28,$0F,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8
     .db $10,$F1,$04,$18,$DC

     dec a
     jr nz,$+36h
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$05,$C8,$05
     .db $28,$1F,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A
     .db $B6,$77,$13,$23,$0D,$20,$F8,$10,$E1,$04,$18,$CC

     .db $3D,$20,$33,$0E,$0C,$11
     .dw RectData
     .db $1A,$B6,$77,$13
     .db $23,$0D,$20,$F8,$05,$C8,$05,$28,$1E,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$E1
     .db $0E,$0C,$11
     .dw RectData+12
     .db $1A,$B6,$77,$13,$23,$0D,$20,$F8,$10,$E2,$04,$18,$CD,$3D,$20,$34,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$1E,$E5,$0E,$0C,$11
     .dw RectData
     .db $1A,$B6
     .db $77,$13,$23,$0D,$20,$F8,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$10,$E2,$04,$18
     .db $CC,$3D,$20,$35,$0E,$0C,$11
     .dw RectData
     .db $1A,$A6,$AE,$77,$13,$23,$0D,$20,$F7,$05,$C8,$05,$28,$1F,$E5
     .db $0E,$0C,$11
     .dw RectData
     .db $1A,$AE,$77,$13,$23,$0D,$20,$F8,$E1,$0E,$0C,$11
     .dw RectData+12
     .db $1A,$A6,$AE,$77,$13
     .db $23,$0D,$20,$F7,$10,$E1,$04,$18,$CB,$3D,$20,$37,$05,$C8,$F3,$E5,$D9,$01,$0C,$00,$E1,$09,$D9,$0E
     .db $0C,$11
     .dw RectData
     .db $D5,$D9,$D1,$D9,$1A,$2F,$A6,$D9,$47,$1A,$A6,$B0,$13,$23,$D9,$77,$13,$23,$0D,$20
     .db $EF,$10,$E4,$0E,$0C,$11
     .dw RectData
     .db $1A,$2F,$A6,$77,$13,$23,$0D,$20,$F7,$FB,$C9

     .db $3D,$20,$40,$F3,$C5
     .db $11,$0C,$00,$19,$10,$FD,$2B,$E5,$D9,$11,$F4,$FF,$E1,$19,$D9,$C1,$05,$C8,$0E,$0C,$11
     .dw RectData+11
     .db $D5
     .db $D9,$D1,$D9,$1A,$2F,$A6,$D9,$47,$1A,$A6,$B0,$1B,$2B,$D9,$77,$1B,$2B,$0D,$20,$EF,$10,$E4,$0E,$0C
     .db $11
     .dw RectData+11
     .db $1A,$2F,$A6,$77,$1B,$2B,$0D,$20,$F7,$FB,$C9

     dec a
     ret z
     dec a
     ret z
     exx
     ld de,0
     ld c,8
     exx
PxlTestRect:
     dec a
     jr nz,PxlTestBorder
     ld c,12
     ld de,RectData
PxlTstRectLoop:
       call PxlTestWithMask
       djnz PxlTstRectLoop-5
       exx
     ex de,hl
     jp SetXXXXAns
;       ld b,d
;       ld c,e
;       ret
PxlTestBorder:
     dec a
     ret nz
     ld c,12
     ld de,RectData
     call PxlTestWithMask
     dec b
     jr z,PxlTestBorder-4
     dec b
     jr z,PxlTestBrdrEnd
     ld c,12
     ld de,RectData+12
PxlTstBrdrLoop:
       call PxlTestWithMask
       djnz PxlTstBrdrLoop-5
PxlTestBrdrEnd:
     ld de,RectData
     ld c,12
     call PxlTestWithMask
     exx
     ex de,hl
     jp SetXXXXAns
;       ld b,d
;       ld c,e
;       ret
PxlTestWithMask:
     ld a,(de)
     and (hl)
     exx
     ld b,c
     add a,a
     jr nc,$+3
     inc de
     jr z,$+4
     djnz $-6
     exx
     inc de
     inc hl
     dec c
     jr nz,PxlTestWithMask
     ret
NewVar:
     call LoadInc
     push de
     call LoadInc
     or a
     res 1,(iy+33)
     jr nz,$+6
     set 1,(iy+33)
     call LoadTypeVarName
     bit 1,(iy+33)
     jr z,$+8
       jr c,$+6
       bcall(4FC6h)
       scf
     jp nc,BAD_NAME
     pop hl
     ld a,(8478h)
     push hl
     bcall(4E70h)
     inc de
     inc de
     push de
     bcall(41C8h)
     pop de
     pop bc
     ld a,b
     or c
     ret z
     dec bc
ZeroMemF:
     xor a
SetMemF:
     ld (de),a
     ld h,d \ ld l,e
     inc de
     ld a,b
     or c
     ret z
     ldir
     ret

GetStats:
       call LoadInc
       or a
       jr z,$+6
       set 2,(iy+33)
;       call FindVarNameArc
     call LoadTypevarName
     push bc
     call GetStatsArc
     pop hl
     bit 2,(iy+33)
     jr z,$+9
       add hl,bc
       ld bc,9
       add hl,bc
       ld b,h
       ld c,l
       push af
       push de
       push bc
       ld de,3
       call MakeAnsList
       pop hl
       call SetXXXXDE
       pop hl
       ld l,(hl)
       ld h,0
       call SetXXXXDE
       pop af
       ld h,0
       ld l,a
       jp SetXXXXDE
AnsType:
       bcall(4AD7h)
       bcall(478Fh)
       ret
Get2Key:
       call TwoKeys
       jp SetXXXAns+3
SpeedyKeys:
       call LoadInc
       ld (Delay),a
       call LoadInc
       ld (Repeat),a
       in a,(6)
       ld hl,SpeedyKeyHook
       bcall(4F66h)
       ret
DisableKeyHooks:
       res 5,(iy+34h)
       ret
TransformSprite:
;Inputs:
;     A is the number of shifts to perform
;     B is the max width in bytes to cut off
;     C is the max height in pixels to cut off
;     D is the byte width of the sprite
;     E is the pixel height of the sprite
;     HL is the buffer to copy to.
;     IX points to the sprite data
;     (TSBG) is 00 for white, FF for black
;Output:
;     B is the byte width adjusted
;     C is the adjusted height
;     DE is zero
;     HL points to the sprite data
     di
     push bc
     ex af,af'
     ld a,b
     ex af,af'
     ld b,a
     ld a,d
     exx
     ld de,(TSBG-1)
     pop bc
     inc a
     sub b
     exx

     res 1,(iy+33)
     jr nc,$+3
     xor a
     jr z,$+7
       set 1,(iy+33)
       dec a
     ld c,a
     ld a,e
     exx
     cp c
     jr c,$+3
       ld a,c
     exx
     ld e,a
     push bc
     push hl
     ld b,0
TSLoop1:
     push de
     push de
     ex af,af'
     ld e,a
     ex af,af'
     ld a,(ix)
     ld (hl),a
     inc ix
     inc hl
     dec e
     jr z,$+5
     dec d
     jr nz,TSLoop1+5
     add ix,bc
     ld a,e
     or a
     jr z,$+7
       exx
       ld a,d
       exx
       ld (hl),a
       inc hl
     pop de
     dec e
     jr nz,TSLoop1+1
     pop de
     pop hl
     pop bc
;At this point, the sprite is copied to the buffer
;Now its data can be shifted
;A' is the max width
     ld a,d
     exx
     cp b
     exx
     jr c,$+5
     ex af,af'
     ld d,a
     ex af,af'

     push de
     ld a,b
     or a
     jr z,TSExit
TSLoop2:
     push de
     push hl
     push bc
     push de
     exx
     rlc d
     exx
       rr (hl)
       inc hl
       dec d
       jr nz,$-4
     bit 1,(iy+33)
     jr nz,$+5
     rr (hl)
     inc hl
     pop de
     dec e
     jr nz,TSLoop2+3
     pop bc
     pop hl
     pop de
     djnz TSLoop2
TSExit:
     pop bc
     bit 1,(iy+33)
     jr z,$+6
       res 2,(iy+33)
     res 1,(iy+33)
     ld a,b
     exx
     cp b
     exx
     ret nc
     inc b
     ret
HexSpriteVar:
     call FindVarNameArc
     or a
     jp nz,ARCH
     jr $+5
HexSprite:
     ld hl,9340h
     ld (TempWord5),hl
     call LoadInc
     or a
     jr nz,$+6
     set 3,(iy+33)
     call StringOrName
     or a
     jp nz,ARCH
     di
     ex de,hl
     ld hl,9872h         ;I really didn't want to use this, but to be safe...
     srl b
     rr c
     push hl
     pop ix
     push bc
     call HexTok
     jr grglt
TokSpriteVar:
     call FindVarNameArc
     or a
     jp nz,ARCH
     jr $+5
TokSprite:
     ld hl,9340h
     ld (TempWord5),hl
     call LoadInc
     or a
     jr z,$+6
     set 3,(iy+33)
     call StringOrName
     or a
     jp nz,ARCH
     push hl
     pop ix
     push bc
grglt:
     call LoadInc
     pop hl
     dec a
     cp 40h
     jp nc,HEIGHT
     inc a
     ld c,a
     call HL_Div_C
     or a
     jr z,$+3
       inc l
     ld a,l
     cp 12
     jp z,WIDTH
     ld b,a
     push bc          ;BC= (w,h)    stack={wh,)
     call LoadInc
     bit 3,(iy+33)
     jr z,$+10
       res 3,(iy+33)
       add a,a
       add a,a
       add a,a
       ld e,a
     cp 96
     jp nc,BAD_X
     and 7
     jr nz,$+6
       set 2,(iy+33)
     sra e
     sra e
     sra e
     ld (RectData+1),de       ;X byte
     push af        ;x pixel
     ld a,12
     sub e
     push af        ;max width in bytes
     call LoadInc
     cp 64
     jp nc,BAD_Y
     pop hl
     pop bc
     ld (RectData+2),de
;ld de,(rectdata+1)
;d=Y,e=x
     ld a,64
     sub e
     ld l,a
     push hl        ;pop bc
     push bc        ;pop af


     call LoadInc   ;type      (save)
     ld h,a
     or a
     jr z,$+6
       res 2,(iy+33)
     dec a
     jr nz,$+3
       dec d
     ld a,d
     ld (TSBG),a
;save hl
      pop af
      pop bc
      pop de
DrawPixelCoordSprite2:
; h is the type
; (RectData+2)=Y
; (rectdata+1)=X
; D is height
; E is width
; (TempWord5) is the buf
; A is the shift amount
; B is the max 
;IX points to the sprite data
      push hl
      ld hl,86ECh
     call TransformSprite
     pop af    ;A is the type
     ld de,(RectData+2)
     ld d,0
     push hl
     ld h,d
     ld l,e
     add hl,de
     add hl,de
     add hl,hl
     add hl,hl
     ld de,(RectData+1)
     ld d,0
     add hl,de
     ld de,(TempWord5)
     add hl,de
     pop de
     bit 2,(iy+33)
     jr z,$+4
       dec b
       ret z
     res 1,(iy+33)
DrawSpriteXxY:
;
;Inputs:
;     A is the method
;     B is the width (in bytes)
;     C is the height (in pixels)
;     DE points to the sprite data
;     HL points to the output location
;Outputs:
;     HL is A*12 larger (next sprite down?)
;     DE points to the next byte after the sprite data
;     A is 0
;     B is not changed
;     C is 12-B
;
       push af             ; push af 
       ld a,c              ;79
       di                  ;F3
       ex af,af'           ;08
       ld a,12             ;3E0C
       sub b               ;90
       ld c,a              ;4F
       pop af              ;\ pop af 
OverwriteXxY:
       or a                ; or a 
       jr nz,ANDXxY        ;2010
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-4            ;10FA         
           add hl,bc           ;09
           bit 2,(iy+33)
           jr z,$+3
           inc de
           pop af              ;
           pop bc              ;
           dec a               ;3D
           jr nz,$-19          ;20F2
         res 2,(iy+33)
         ret                 ;C9
ANDXxY:
       dec a               ;3D
       jr nz,XORXxY        ;2011
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             and (hl)            ;A6
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-5            ;10F9
           add hl,bc           ;09
           pop af              ;\ pop af 
           pop bc              ;\ pop bc 
           dec a               ;3D
           jr nz,$-13          ;20\ pop af 
         ret                 ;C9
XORXxY:
       dec a               ;3D
       jr nz,ORXxY         ;2011
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             xor (hl)            ;AE
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-5            ;10F9
           add hl,bc           ;09
           pop af              ;\ pop af 
           pop bc              ;\ pop bc 
           dec a               ;3D
           jr nz,$-13          ;20\ pop af 
         ret                 ;C9
ORXxY:
       dec a               ;3D
       jr nz,EraseXxY
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             or (hl)             ;B6
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-5            ;10F9
         add hl,bc           ;09
         pop af              ;\ pop af 
         pop bc              ;\ pop bc 
         dec a               ;3D
         jr nz,$-13          ;20F1 
         ret                 ;C9
EraseXxY:
         dec a               ;3D
         ret nz
         ex af,af'           ;08
           push bc             ; push bc 
           push af             ; push af 
             ld a,(de)           ;1A
             cpl                 ;2F
             and (hl)            ;A6
             ld (hl),a           ;77
             inc de              ;13
             inc hl              ;23
             djnz $-6            ;10F8
           add hl,bc           ;09
           pop af              ;\ pop af 
           pop bc              ;\ pop bc 
           dec a               ;3D
           jr nz,$-14          ;20F0
         ret                 ;C9
SearchReplace:
     call FindVarNameArc
     or a
     jp nz,ARCH
     ld (TempWord5),hl
     push hl
     push bc
     add hl,bc
     ld (9311h),hl
     call StringOrName
     or a
     jp nz,ARCH
     ld (84EDh),hl
     push bc
     call StringOrName
     ld (TempWord6),a
     ld (TempWord3),bc
     ld (84EBh),hl
     ld h,b
     ld l,c
     pop bc
     or a
     sbc hl,bc
     res 0,(iy+33)
     jr c,$+9
        ld (TempWord4),hl
        set 1,(iy+33)
;     pop hl
;     or a
;     sbc hl,bc
;     inc hl
;     push hl
     pop ix
     pop hl
ReplaceLoop:
     ld de,(84EDh)
     call SearchString+4
     jr c,ContinueSR
ResizeSR:
       res 1,(iy+33)
       ld de,(TempWord5)
       ld hl,(9311h)
       or a
       sbc hl,de
       ex de,hl
       dec hl
       ld (hl),d
       dec hl
       ld (hl),e
       bit 1,(iy+33)
       ret z
       res 1,(iy+33)
       jp MEM
ContinueSR:
     or a
     sbc hl,bc
     push bc
     bit 1,(iy+33)
     jr z,$+12
       push hl
       ld hl,(TempWord4)
       bcall(42FDh)
       pop hl
       jr c,ReSizeSR+4
     pop de
     push de
;DE is the size of the data to delete
;HL points to where to delete the data
;     push hl
     bcall(4357h)
     ld hl,(TempWord3)
;     bcall(42FDh)
;     jp c,MEM
;     ex de,hl
;     pop de
     bcall(42F7h)
     ld bc,(TempWord3)
     ld hl,(84EBh)
     ld a,(TempWord6)
     push ix
     call ReadArc
     pop ix
     ex de,hl
     pop bc
     jp ReplaceLoop

InsertLine:
; jr $ 
;     call StringOrName
;     push af
;     inc bc
;     push bc
;     ld (84EBh),hl
;     ld h,b
;     ld l,c
;     bcall(42FDh)
;     jp c,TOO_BIG
;     di
;     call FindLine
;     ex de,hl
;     pop de
;     scf \ ccf
;     jr z,$+9
;       dec hl
;       cp (hl)
;       jr z,$+5
;         dec de
;         inc hl
;         scf
;     ex af,af'          ;c flag set means no extra newline token
;     ld a,b
;     or a
;     jp nz,BAD_NUMBER
;     or c
;     jr z,$+6
;       dec a
;       jp nz,BAD_NUMBER
;     ex af,af'          ;c flag means no newline
;     bit 0,c            ;z flag means {data,newline}, nz means {newline,data}
;     ex af,af'
;     ex de,hl
;;HL is how many bytes to insert
;;DE is where to insert
;     push de
;     push hl
;     bcall(42F7h)
;     ld hl,(TempWord2)
;     dec hl
;     ld b,(hl)
;     dec hl
;     ld c,(hl)
;     ld a,b
;     or c
;     ex de,hl
;     pop hl
;     push hl
;     add hl,bc
;     ex de,hl
;     ld (hl),e
;     inc hl
;     ld (hl),d
;     pop bc
;     pop de
;     pop af
;     ex af,af'
;;c flag means no newline
;;z flag means {data,newline}, nz means {newline,data}
;     jr c,$+7
;     dec bc
;     jr z,$+4
;       ld (de),a      ;only included for the case where we are inserting at the end of the file. otherwise, not needed
;       inc de
;     ex af,af'
;     ld hl,(84EBh)
;     call ReadArc
;     ex af,af'
;     ret c
;     ret nz
;     ld (de),a
;     ret
DelLine:
     call FindLine
     push af
     ld a,b
     or c
     jp nz,BAD_NUMBER
     pop af
     ex de,hl
     jr z,$+9
       dec hl
       inc de
       cp (hl)
       jr z,$+4
         inc hl
         dec de
     ld a,d
     or e
     ret z
;HL points to where to delete
;DE is the number of bytes to delete
     push de
     bcall(4357h)
     ld hl,(TempWord2)
     dec hl
     ld d,(hl)
     dec hl
     ld e,(hl)
     pop bc
     ex de,hl
     or a
     sbc hl,bc
     ex de,hl
     ld (hl),e
     inc hl
     ld (hl),d
     ret
FindLine:
;A is the newline token
;BC is the number of lines left
;DE points to the line start
;HL is the size of the line
;z flag means that the last byte found was a newline
;(TempWord1) remaining number of bytes in the variable
;(TempWord2) points to the start of data in the var
     call LoadInc
     push af
     call LoadInc
     or e
     jp z,BAD_NUMBER
     push de
     call FindVarNameArc
     or a
     jp nz,ARCH
     ld d,b
     ld e,c
     or b
     or c
     pop bc
     ld (TempWord2),hl   ;84b1
     jr nz,$+11
       pop de
       xor a
       ld a,d
       ld de,0
       dec bc
       ex de,hl
       ret
     pop af
RAMSearchLine:
;Input:
;     A is the newline byte
;     BC is the line number to find
;     DE is the size of the variable
;     HL points tot he start of the data
;Output:
;     A is the newline byte
;     BC is the number of lines left
;     DE points to the start of the line
;     HL is the size of the line
;     (TempWord1) remaining number of bytes in the variable
     ld (TempWord1),de
     dec bc
     inc b
     inc c
FindLineLoop:
     ld d,h
     ld e,l
     push bc
     ld bc,(TempWord1)
     cpir
     ld (TempWord1),bc
     pop bc
     jp po,EOFFound
     dec c
     jr nz,FindLineLoop
     dec b
     jr nz,FindLineLoop
     jr grtwlt
EOFFound:
     push af
     jr nz,$+17
       dec c
       jr nz,$+3
       dec b
       jr z,$+6
       dec c
       jr nz,$+3
       dec b

       ld d,h
       ld e,l
       dec de
       jr grtwlt-1
     dec c
     jr nz,$+3
     dec b
     jr z,$+4
       ld d,h
       ld e,l
     pop af
grtwlt:
     push af
     dec c
     dec b
     inc bc
     or a
     sbc hl,de
     pop af
     ret
DBRead:
     ld ix,SearchLineData
     call LoadTSA
     call LoadInc
     ld (TempWord3),a
     call LoadInc
     push de
     call FindVarNameArc
     inc bc
     ld (TempWord2),bc
     pop bc
     dec bc
     inc b
     inc c
DBLineLoop:
       push bc
       ld de,(TempWord3)
       ld bc,(TempWord2)
       call TSA
       ld (TempWord2),bc
       pop bc
       jp po,EOFHit
       dec c
       jr nz,DBLineLoop
       dec b
       jr nz,DBLineLoop
       jr stoline
EOFHit:
     dec hl  
     jr nz,stoline-4
     ld d,h
     ld e,l
     inc hl
     jr StoLine
     dec c
     jr nz,stoline
     dec b
stoline:
     scf
     sbc hl,de
     dec c
     dec b
     inc bc
;BC is the number of lines left
;DE points to the start of the line
;HL is the size
     inc b
     dec b
     jp m,NOLs
     push af
     ld a,b
     or c
     jp nz,EOFErr
     push de
     call MakeAnsStrHL
     pop hl
     pop af
     jp ReadArc
;Returning the number of lines in the file
NOLs:
     ld a,b \ cpl \ ld h,a
     ld a,c \ cpl \ ld l,a
     inc hl
     jp SetXXXXAns
Draw:
       ld hl,9340h
       ld (TempWord5),hl
       call LoadInc
       push af
       cp 4
       jr nc,$+26
         call LoadInc
         push de
         call LoadInc
         pop bc
         ld b,a
         call GetPixelLoc
         push af
         push hl
         and (hl)
         jr z,$+4
         ld a,1
         call SetXXXAns
         pop hl
         pop af
       pop bc
       inc b
       dec b
       ret z
       djnz $+6
         cpl
         and (hl)
         ld (hl),a
         ret
       djnz $+5
         or (hl)
         ld (hl),a
         ret
       djnz $+5
         xor (hl)
         ld (hl),a
         ret
       or a
       djnz $+17
FillScreen:
         sbc a,a
         ld de,(TempWord5)
         ld (de),a
         ld h,d
         ld l,e
         inc de
         ld bc,767
         ldir
         ret
       djnz $+5
         scf \ jr FillScreen
       djnz $+17
         ld hl,(TempWord5)
         ld bc,768
InvScreenLoop:
           ld a,(hl)
           cpl
           ld (hl),a
           cpi
           jp pe,InvScreenLoop
           ret
       ld a,b
       cp 7
       jr nc,$+50
         push bc
         call LoadInc
         pop bc
         ld a,b
         cp 4
         jr nc,$+15
           ld h,d
           ld l,e
           add hl,hl
           add hl,de
           add hl,hl
           add hl,hl
           ld de,(TempWord5)
           add hl,de
           jr $+27
         ld hl,(TempWord5)
         push af
         ld a,e
         rrca \ rrca \ rrca
         and 0Fh
         ld c,a
         ld a,e
         ld b,0
         add hl,bc
         and 7
         ld b,a
         inc b
         ld a,1
           rrca
           djnz $-1
       pop bc
       or a
       djnz $+13
HorizontalLine:
         sbc a,a
         ld (hl),a
         ld d,h
         ld e,l
         inc de
         ld bc,11
         ldir
         ret
       djnz $+5
         scf \ jr HorizontalLine
       djnz $+11
         ld b,12
           ld a,(hl)
           cpl
           ld (hl),a
           inc hl
           djnz $-4
         ret
VerticalLine:
       ld de,12
       djnz $+13
         ld b,40h
         cpl
         ld c,a
           ld a,c
           and (hl)
           ld (hl),a
           add hl,de
           djnz $-4
         ret
       ld c,a
       djnz $+11
         ld b,40h
           ld a,c
           or (hl)
           ld (hl),a
           add hl,de
           djnz $-4
         ret
       djnz $+11
         ld b,40h
           ld a,c
           Xor (hl)
           ld (hl),a
           add hl,de
           djnz $-4
         ret
;Insert More Here
       ret
GetPixelLoc:
;Input:
;     b is X
;     c is y
;Output:
;     HL points to byte
;     A is the mask
;     nc if not computed, c if computed
       ld a,c
       cp 64 \ ret nc
       ld a,b
       cp 96 \ ret nc
       ld l,c
       ld h,0
       ld b,h
       add hl,hl
       add hl,bc
       add hl,hl
       add hl,hl
       ld b,a
       rrca \ rrca \ rrca
       and 0Fh
       ld c,a
       ld a,b
       ld b,0
       add hl,bc
       ld bc,(TempWord5)
       add hl,bc
       and 7
       ld b,a
       inc b
       ld a,1
         rrca
         djnz $-1
       scf
       ret
GetVersion:
       ld hl,11
       call MakeAnsStrHL+5
       ld a,3Ah
       ld hl,Version
       ex de,hl
       ld (hl),34h
       inc hl
       ld (hl),a
       inc hl
       ex de,hl
       ldi
       ldi
       ld (de),a
       inc de
       ldi
       ldi
       ldi
       ld (de),a
       inc de
       ldi
       ldi
       ret
ZeroMemE:
     xor a
SetMemE:
     ld (de),a
     ld h,d \ ld l,e
     dec de
     lddr
     ret
BaseX:
     call ClrLargeNumBuf
     call LoadInc
     or a
     jr nz,$+4
       ld a,16
     cp 37
     jp nc,BAD_NUMBER
     push af
     call StringOrName
     or a
     jp nz,ARCH
     pop af
     ld de,86ECh
     call ConvStr         ;Converted to just data
     ld hl,86ECh
     ld c,(hl)
     inc hl
     ld b,(hl)
     or a
     ld hl,382
     sbc hl,bc
     jp c,TOO_BIG
     call LoadInc
     or a
     jr nz,$+5
     ld a,10
     ld e,a
     cp 2
     jp c,BAD_NUMBER
     cp 37
     jp nc,BAD_NUMBER
     call ConvBigNumToRadix
     inc hl
     push hl
     call LoadInc
     ld b,d
     ld c,e
     pop de
     or b           ;resetting the c flag
     ld hl,89ECh
     sbc hl,de
;HL is the size
;DE is the location
;BC is the resize
     or b
     jr z,NoResize
       sbc hl,bc
       jr nc,NoResize-5
         ld a,48
;         dec hl
;         inc h
;         inc l
           dec de
           ld (de),a
           inc l
           jr nz,$-3
           inc h
           jr nz,$-6
           jr $+5
       ex de,hl
       add hl,de
       ex de,hl
       ld h,b
       ld l,c
NoResize:
     push de        ;location
     call MakeAnsStrHL
     pop hl
     ldir
     ret
Num1Loc    equ TempWord1
Num1Size   equ TempWord2
Num2Loc    equ TempWord3
Num2Size   equ TempWord4
Num3Loc    equ TempWord5
Num3Size   equ TempWord1-2
output     equ Num3Loc
ClrLargeNumBuf:
     ld hl,86ECh
     xor a
     ld bc,300h
       ld (hl),a
       inc hl
       dec c
       jr nz,$-3
       dec b
       jr nz,$-6
     ret
ConvBigNumToRadix:
;E is the radix
     ld hl,86ECh
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl

     ld (Num1Loc),hl
     ld (Num1Size),bc
     ld hl,89EBh
Div_By_1Byte:
     push hl
     dec bc
     inc b
     inc c
     xor a
DivByteLoop0:
     push bc
     ld b,8
DivByteLoop:
     push bc
     ld bc,(Num1Size)
     ld hl,(Num1Loc)
     dec bc
     inc b
     inc c
     or a
       rl (hl)
       inc hl
       dec c
       jr nz,$-4
       dec b
       jr nz,$-7
     rl a
     cp e
     jr c,$+7
       ld hl,(Num1Loc)
       inc (hl)
       sub e
     pop bc
     djnz DivByteLoop
     pop bc
     dec c
     jr nz,DivByteLoop0
     dec b
     jr nz,DivByteLoop0
     pop hl
     cp 10
     jr c,$+4
     add a,7
     add a,30h
     ld (hl),a
     push hl

     ld hl,(Num1Loc)
     ld bc,(Num1Size)
     add hl,bc
     dec hl
     ld a,(hl)
     or a
     jr z,$+3
       inc bc
     pop hl
     cpd
     ld (Num1Size),bc
     jp pe,Div_By_1Byte
     ret
ConvStrBase10:
     ld a,10
ConvStr:
;Inputs:
;     HL points to the string data
;     DE points to where the string gets converted to
;     BC is the size of the string
;     A is the base of the number
     push hl
     ld hl,1
     ld (847Ah),a
     ld (8478h),hl
     dec l
     ld (9872h),hl
     ld (9874h),hl
     jr Part1
MulBy1_Byte:
     push hl
     push bc
     push de
     ld hl,8478h
     ld bc,9872h
     push bc
     call AP_Mul_AP
     pop hl
     ld bc,384
     pop de
     push de
     ldir
     pop de
     pop bc
Part1:
     pop hl
     ld a,(hl)
     sub 30h
     cp 10
     jr c,$+7
       cp 17
       ret c
       sub 7
     ex de,hl
     inc (hl)
     inc hl
     inc hl
     add a,(hl)
     ld (hl),a
     dec hl
     dec hl
     ex de,hl
     cpi
     jp pe,MulBy1_Byte
     or a
     ret
ArbMultStart:
;===============================================================
AP_Mul_AP:
;===============================================================
;Inputs:
;     HL points to the first number (little-endian, size prefix 2 bytes)
;     DE points to the second number (little-endian, size prefix 2 bytes)
;     BC points to the output location
;Output:
;     The RAM at HL contains the product (little-endian with size prefix)
;Notes:
;     This will erase bytes of RAM at (HL) equal to the
;     size of the first number plus the size of the second.
;     So if you use saveSScreen:
;         First number uses 2+M bytes
;        Second number uses 2+N bytes
;        Output number uses 2+M+N bytes
;     At most, 2+N+2+M+2+M+N=768.
;        2+N+2+M+2+M+N = 768
;              6+2M+2N = 768
;               2(M+N) = 762
;                  M+N = 381
;     In otherwords, you can multiply two, 190 byte numbers. In
;     Decimal, this comes out to roughly two 457 digit numbers
;     to get up to 915 digit numbers. It requires 14952 bytes of
;     RAM to use two numbers >9000 digits
;===============================================================
     di
;First, we get the size
     ld (output),bc   ;4 bytes, save the output location
     ld c,(hl)
     inc hl
     ld b,(hl)
     ld a,c
     or b
     ret z
     inc hl
     ld (Num1Loc),hl  ;3 bytes, save the location of the first number
     ld (Num1Size),bc ;4 bytes, save the size
     ex de,hl
     ld e,(hl)
     inc hl
     ld d,(hl)
     ld a,e
     or d
     ret z
     add hl,de
     ld (Num2Loc),hl  ;3 bytes, save the location
     ld (Num2Size),de ;4 bytes, save the size
     ex de,hl
     add hl,bc        ;size of the output RAM
;Now we clear out the bytes for the output
     ld b,h
     ld c,l
     ld hl,(output)
     ld (hl),c
     inc hl
     ld (hl),b
     inc hl
     ld (output),hl
     ld (Num3Size),bc
     xor a
       ld (hl),a
       cpi
       jp pe,$-3
;Now we start multiplying stuff
;We need to do:
;     hl=(Num2Loc)
;     de=(Num1Loc)
;     ix=(output)
;     bc=(Num2Size)
;(hl)_Times_(de)_To_(ix)
   exx
   ld bc,(Num3Size)
   exx
   ld bc,(Num2Size)
;   ld hl,(Num2Loc)
   ex de,hl
Loop1:
   push bc
   ld b,8
Loop2:
;===============================================================
;   rl (output)
;===============================================================
     exx
     ld hl,(output)
     ld d,b
     ld e,c
     dec de
     inc d
     inc e
     or a
       rl (hl)
       inc hl
       dec e
       jr nz,$-4
       dec d
       jr nz,$-7
     exx
;===============================================================


   rlc (hl)
   jr nc,NoAdd
;add (output),(Num1Loc)
     exx
     ld de,(Num1Loc)
     push bc
     ld bc,(Num1Size)
     dec bc
     inc c
     inc b
     ld hl,(output)
     or a
AddLoop:
       ld a,(de)
       adc a,(hl)
       ld (hl),a
       inc hl
       inc de
       dec c
       jr nz,AddLoop
       dec b
       jr nz,AddLoop
       jr nc,$+3
       inc (hl)
     pop bc
     exx
NoAdd:
   djnz Loop2
   pop bc
   cpd
   jp pe,Loop1
   ld hl,(output)
   ld bc,(Num3Size)
   add hl,bc
   dec hl
   inc bc
   xor a
     cpd
     jp po,$+5
     jr z,$-5
   ld hl,(output)
   dec hl
   ld (hl),b
   dec hl
   ld (hl),c
   ret
DelVar:
     ld bc,-6
     ld hl,(ArgLoc)
     add hl,bc
     xor a
     rld
     push af
     call LoadTypeVarName
     pop bc
     ld c,b
     ld b,a
     ret c
; c is the command
; b is the flash page
     inc c
     dec c
     jr nz,$+6
       bcall(4FC6h)
       ret
;a,b is the flash page     
;c=1 means arc
;c=2 means unarc
     sub 1
     sbc a,a
;a=00 means flash
;a=FF means RAM
     xor c
     ;a=01 means archived already
;a=02 means toggle
;a=FD means unarchived already
;a=FE means toggle
     and 1
     ret nz
     bcall(4FD8h)
SetAns1:
     bcall(_OP2Set1)
     ret          


CopyProg:
       call FindVarNameArc
       push af
       push hl
       push bc
       call LoadTypeVarName
       jr c,$+5
         bcall(4FC6h)
       pop hl
       push hl
       ld a,(8478h)
       and 1Fh
       bcall(4E70h)
       inc de
       inc de
       push de
       bcall(41C8h)
       pop de
       pop bc
       pop hl
       pop af
       jp ReadArc
RealToStr:
       ld hl,1
       call MakeAnsStrHL+5
       push de
       call LoadInc
       pop hl
       ld (hl),a
       ret
ListToStr:
     call LocateVar
     cp 13
     jr nz,$+8
       sla c
       rl b
       jr List2Str
     cp 1
     jr z,List2Str
     cp 4
     ret nz
       push de
       ld d,b
       ld e,c
       call MakeAnsList
       pop hl
StrToListLoop:
       push bc
       push hl
       ld l,(hl)
       ld h,0
       call SetXXXXDE
       pop hl
       pop bc
       cpi
       jp pe,StrToListLoop
       ret
List2Str:
     push de
     call MakeAnsStrX
     pop hl
     push bc
     push de
     call ConvDecAtHL
     pop de
     ld (de),a
     pop bc
     inc de
     dec bc
     ld a,b
     or c
     jr nz,$-12
     ret
Left:
       call StringOrName
       push hl
       push af
       call LoadInc
       ex de,hl
       call MakeAnsStrHL
       pop af
       pop hl
       jp ReadArc
Right:
       call StringOrName
       push af
       add hl,bc
       push hl
       call LoadInc
       pop hl
       sbc hl,de
       push hl
       ex de,hl
       call MakeAnsStrHL
       pop hl
       pop af
       call CorrectOffset
       jp ReadArc
Mid:
       call StringOrName
       push af
       push hl
       call LoadInc
       pop hl
       add hl,de
       push hl
       call LoadInc
       ex de,hl
       call MakeAnsStrHL
       pop hl
       pop af
       jp ReadArc
ExecVarBASIC:
       call FindvarNameArc
       jp c,BAD_NAME
       or a
       jp nz,ARCH
       ld a,(iy+8)
       push af
       set 1,(iy+8)
       bcall(4A9Bh)
       pop af
       ld (iy+8),a
       ret
GetProgName:
       bcall(441Dh)    ;CpyTo3FPST
       ld hl,848Eh

       push hl
       ld bc,9
       xor a
       cpir
       jr nz,$+3
         inc c
       ld a,9
       sub c
       ld c,a
       call MakeAnsStrX
       pop hl
       push de
       ldir
       pop hl
       ld a,(hl)
       add a,40h
       ld (hl),a
       ret
;
PutSC:
;
;Inputs:
;     a is the char to draw
;     (textRow) is the pixel row to draw at
;     (textCol) is the text column to draw at (0 to 23)
;
        push af
        ld bc,(textRow)
        ld a,b
        cp 24
        ld a,c
        jr c,$+6
          ld b,0
          add a,6
        cp 3Bh
        jr c,$+8
          sub 3Ch
          jr nc,$+4
            add a,6
        ld c,a
        inc b
        ld (textRow),bc
        dec b
        ld hl,BatLibFont
        pop af
;===============================================================
PutFS:
;===============================================================
        push bc
        push hl
        ld b,0
        ld c,a
        ld h,b
        ld l,c
        add hl,hl
        add hl,bc
        pop de
        add hl,de
        pop bc
        push hl
        ld a,b
        ld b,0
        ld h,b
        ld l,c
        add hl,hl
        add hl,bc
        add hl,hl
        add hl,hl
        rra
        push af
        ld c,a
        add hl,bc
        ld bc,9340h
        add hl,bc
        ld bc,060Ch

        pop af
        pop de
        jr c,PutRight
;
PutLeft:
;
        ld a,(hl)
        and 0Fh
        ld (hl),a
        ld a,(de)
        bit 0,b
        jr z,$+7
          rlca \ rlca \ rlca \ rlca
          inc de
        and $F0
        or (hl)
        ld (hl),a
        ld a,b
        ld b,0
        add hl,bc
        ld b,a
        djnz PutLeft
        ret
;
PutRight:
;
        ld a,(hl)
        and $F0
        ld (hl),a
        ld a,(de)
        bit 0,b
        jr nz,$+7
          rlca \ rlca \ rlca \ rlca
          dec de
        inc de
        and 0Fh
        or (hl)
        ld (hl),a
        ld a,b
        ld b,0
        add hl,bc
        ld b,a
        djnz PutRight
        ret
bbrawr:
       call LocateStr
       ex de,hl
;
PutSM:
;
;Inputs:
;     hl points to the string to display
;     bc is the size of the string
;
        ld a,b \ or c \ ret z
        push bc
        push hl
        ld a,(hl)
        call PutSC
        pop hl
        pop bc
        cpi
        jp pe,PutSM+3
        ret
DelElements:
       call LoadInc
       inc de
       push de
       call LoadInc
       push de
       or d
       jp z,BAD_NUMBER
       call ListOrName
       or a
       jp nz,ARCH
       ld a,(de)
       ex de,hl
       dec de
       dec de
       pop hl
       pop bc
       bcall(4A2Fh)
       ret
InsElements:
       call LoadInc
       push de
       call LoadInc
       push de
       or d
       jp z,BAD_NUMBER
       call ListOrName
       or a
       jp nz,ARCH
       ld a,(de)
       ex de,hl
       dec de
       dec de
       pop hl
       pop bc
       bcall(4A2Ch)
       ret
InsertList:
       call ListOrName
       push af
       ld a,b
       or c
       jp z,NO_DATA
       ld h,b
       ld l,c
       add hl,hl
       add hl,hl
       add hl,hl
       add hl,bc
       push hl
       push bc
       rst 18h
       call LoadInc
       pop bc
       ld h,d
       ld l,e
       add hl,hl
       add hl,hl
       add hl,hl
       add hl,de
       push hl
       push bc
       push de
       call ListOrName
       or a
       jp nz,ARCH
       ld a,(de)
       ex de,hl
       dec de
       dec de
       pop bc
       pop hl
       bcall(4A2Ch)
       push de
       bcall(4390h)
       bcall(42F1h)
       inc de
       inc de
       ld (TempWord1),de
       pop de
       pop hl
       inc hl
       inc hl
       add hl,de
       ex de,hl
       pop bc
       ld hl,(TempWord1)
       pop af
       jp ReadArc
InsertBytes:
       call LoadInc
       push de
       call FindVarNameArc
       or a
       jp nz,ARCH
       pop de
       push hl
       push bc
       add hl,de
       push hl
       call StringOrName
       pop de
       ld h,b
       ld l,c
       bcall(42F7h)
       ld bc,-9
       ld hl,(ArgLoc)
       add hl,bc
       ld (ArgLoc),hl
       push de
       call StringOrName
       pop de
       push bc
       call ReadArc
       pop hl
       pop bc
       add hl,bc
       pop de
       ex de,hl
       dec hl
       ld (hl),d
       dec hl
       ld (hl),e
       ret
StringWidth:
       call LocateStr
       ld hl,0
OSSmallFontWidth:
         push bc
         push de
         push hl
         ld a,(de)
         call Is_2_Byte
         push af
         ex de,hl
         bcall(4594h)
         ld hl,848Dh
         ld (hl),a
         bcall(4CB4h)
         ld b,0
         ld c,a
         pop af
         pop hl
         pop de
         add hl,bc
         pop bc
         jr nz,$+4
           dec bc
           inc de
         dec bc
         inc de
         ld a,b
         or c
         jr nz,OSSmallFontWidth
       jp SetXXXAns+3
ReplaceByte:
       call LoadInc
       push af
       call LoadInc
       push de
       call FindVarNameArc
       jp c,BAD_NAME
       or a
       jp nz,ARCH
       pop de
       pop af
       ld d,a
       ld a,b
       or c
       ret z
;D is the byte to search for
;E is the byte to replace with
;HL points to the data
;BC is the size of the var
     ld a,d
     cpir
     ret nz
     dec hl
     ld (hl),e
     inc hl
     jp pe,$-6
     ret
ConvertTokensToASCII:
         push bc
         push hl
         push de
         bcall(4594h)
         pop de
         ld hl,848Eh
         ldir
         pop hl
         pop bc
         ld a,(hl)
         call Is_2_Byte
         jr nz,$+4
           dec bc
           inc hl
         cpi
         jp pe,ConvertTokensToASCII
       xor a
       ret
GetASCIIStr:
     ld hl,(ArgLoc)
     ld a,(hl)
     cp 4
     ret nz
     push de
     call LocateStr
     ex de,hl
     pop de
     jp ConvertTokensToASCII
PopUpMenu:
;y,x,w,"Header","Item","Item",...
     call LoadInc
     push de
     call LoadInc
     pop bc
     ld d,c
     push de
     call LoadInc
     pop hl
     ld (9872h),hl
     ld d,9
     ld (9874h),de

     ld de,9876h
     call GetASCIIStr
     xor a
     ld (de),a
     inc de
     push de
     inc de
     ld b,a
MenuBodyLoop:
       push bc
       call GetASCIIStr
       pop bc
       jr nz,MenuBodyDone
       xor a
       ld (de),a
       inc de
       jr nz,$+6
       inc b
       jp MenuBodyLoop
MenuBodyDone:
     ld a,b
     pop hl
     ld (hl),a
     ld hl,9872h
     call PopUp
 push hl
 bcall(4744h)
 pop hl
     ld h,0
     jp SetXXXXAns
zPutPS:
     bcall(4510h)
     jp (hl)
PutChar6x8:
     ld a,(844Bh)        ;CurRow
     rlca
     rlca
     rlca
     ld c,a
     ld a,(844Ch)
     ld b,a
PutDSprite6x8:
     LCDDelay()
     ld a,80h
     add a,c
     out (16),a
     ld c,16

     xor a
     in e,(c)
     jp m,$-2
     out (16),a

     ld a,5
     in e,(c)
     jp m,$-2
     out (16),a

     ld a,20h
     add a,b
     in e,(c)
     jp m,$-2
     out (16),a

     ld b,8
       ld a,(hl)
       inc hl
       in e,(c)
       jp m,$-2
       out (17),a
       djnz $-9
     ld a,1
     in e,(c)
     jp m,$-2
     out (16),a
     ret
OutChar8x8:
     ld hl,844Ch
     ld a,(hl)
     ld b,a
     cp 12
     ret nc
     dec hl
     ld a,(hl)
     rlca
     rlca
     rlca
     ld l,a
     ld h,b
     ld bc,0801h
     jp DputSprite
SetFileSystHook:
     in a,(6)
     ld (AppPage),a
     ld hl,SetUp
     ld (9BACh),hl
     ld (9BAEh),a
     set 1,(iy+36h)
     ret
MenuInstall:
     di
     ld hl,BatLibFont    ;Use Grammer font
     ld (FontLoc),hl
     ld hl,RamCode
     ld de,RamLoc
     ld bc,RamCodeEnd-RamCode
     ldir
;Back up hook info
     ld a,(8A26h)
     ld (8000h),a
     ld a,(9BAEh)
     ld (8001h),a
     ld hl,(9BACh)
     ld (8002h),hl
     call SetFileSystHook
MainMenu:
     ld hl,VarTypes
     rst 20h
     xor a
     ld de,9340h
     call FillScreen+5
     ld (textRow),bc
     ld hl,SelectProgStr
     call GPutS
     ld a,3
SelectProgLoop:
     push af
     cp 3
     jr nz,$+9
       bcall(_FindAlphaUp) \ jr c,NoMoreProgs
       jr FoundProg
     cp 2
     jr nz,$+7
       bcall(_FindAlphaDn) \ jr c,NoMoreProgs
FoundProg:
     ld hl,8478h
     ld de,8478h+44
     ld bc,9 \ ldir
     xor a
     ld (de),a
NoMoreProgs:
     ld bc,0306h
     ld (textRow),bc
     ld hl,8479h+44
     call GPutS
     ld hl,Str8Space
     call GPutS
     call DispGraphBuffer
     pop af
     ld h,a
     push hl
     call TwoKeys \ pop hl \ cp h
     jr z,$-7
     cp 15 \ jr z,ExitApp
     cp 9
     jr nz,SelectProgLoop
;Prog has been selected
     bcall(4744h)          ;this is a GetKey function
     in a,(2)
     rrca
     and 1
     out (20h),a
     bcall(42F1h)
     ex de,hl
     ld a,b
     or a
     jr z,$+17
       ld b,0
       add hl,bc
       ld c,10
       add hl,bc
       bit 7,h
       jr z,$+3
       inc a
       res 7,h
       set 6,h        
     push hl
     push af        ;flash page saving
     ld hl,TempName
     rst 20h
     pop af
     pop hl
     call ExecProgAtAHL
ExitApp:
     ld a,(8000h)
     ld (8A26h),a
     ld a,(8001h)
     ld (9BAEh),a
     ld hl,(8002h)
     ld (9BACh),hl
     ld hl,8508h
     ld de,966Eh
     ld bc,128
     ldir
     bcall(402Ah)
ExecProgAtAHL:
;HL points to size bytes
;A is the flash page
     ld bc,2
     ld de,8483h
     call ReadArc
     ex de,hl
     dec l
     ld b,(hl)
     dec l
     ld l,(hl)
     push af
     push de
     ld a,16h
     ld h,b
     bcall(4E70h)
     pop hl
     pop af
     inc de
     inc de
     call ReadArc
     bcall(4138h)        ;OP4ToOP1
     set 1,(iy+8)
     bcall(4A9Bh)        ;ParseInp
     res 1,(iy+8)
     ret
CreateVar:
     push bc
     rst 20h
     call ChkFindVar
     jr nc,$+8
       ld a,(hl)
       pop hl
       push hl
       bcall(4E70h)
     pop bc
     inc de
     inc de
     ex de,hl
     push bc
     push hl
     xor a
       ld (hl),a
       cpi
       jp pe,$-3
     pop hl
     pop bc
     ret
;===============================================================
FindVar:
;===============================================================
     ld de,8478h
     ld a,(de)
     and 1Fh
     ld (de),a
     sub 5
     jp z,ChkFindVar+3
     dec a
     jp z,ChkFindVar+3
     sub 15
     jp nc,ChkFindVar+3
;===============================================================
FindSym:
;===============================================================
 ld de,8479h
FindVarSymAtDE: 
 ex de,hl 
FindVarSymAtHL: 
 ld c,(hl) 
 inc hl 
 ld b,(hl) 
SearchVarBC:
 ld hl,$FE60 
SearchForVarLoop: 
  ld a,c 
  cp (hl) 
  dec hl 
  jr nz,$+6             ;2004 is the hex code. I believe this is correct... It skips the next 4 bytes 
   ld a,b 
   cp (hl) 
   jr z,$+16            ;280E This skips the next 14 bytes if z is set. 
  ld de,-8 
  add hl,de 
  ex de,hl 
  ld hl,(9830h) 
  sbc hl,de 
  ex de,hl 
  ld a,d 
  or a 
  ccf 
  jr nz,SearchForVarLoop      ;20E7 
 ld c,3
 inc hl
 inc hl
 ld b,(hl)
 inc hl
 ld d,(hl)
 inc hl
 ld e,(hl)
 inc hl
 inc hl
 inc hl
 ld a,(hl)
 ret
;===============================================================
ChkFindVar:
;===============================================================
;Inputs:
;     OP1 contains the var name to search for
;Outputs:
;     A is the type
;     B is the flashpage
;     C is the name length
;     DE points to the size bytes
;     HL points to the symentry
;Notes:
;     Use to search programs, appvar, groups
;===============================================================
     ld de,8478h
ChkFindVarAtDE:
     ld bc,9
     ld a,(de)
     and 1Fh
     ld (de),a
     ld hl,OP2-1
     cp 5
     jr nz,$+4
     ld (hl),6
     cp 6
     jr nz,$+4
     ld (hl),5
     cp 13
     jr nz,$+5
       ld (hl),1
       xor a
     dec a
     jr nz,$+4
       ld (hl),13
     ex de,hl
     push hl
     jr z,GetNameLength
     inc a
GetNameLength:
     push af
     ld a,b
     cpir
     jr z,$+3
       dec c
     ld a,7
     sub c
     ld c,a
     pop af
     ld a,c
     jr nz,$+8
       inc a
       cp 2
       jr nz,$+3
         inc a
FoundNameLength:
     ld (OP2-2),a
     pop hl
     ld hl,(9830h)
CompareOverLoop:
     ld de,8478h
CompareLoop:
     ld bc,(982Eh)
     or a
     sbc hl,bc
     add hl,bc
     ccf
     ret z
     ld a,(de)
     ld bc,-6
     cp (hl)
     jr z,TypeMatch
     ld a,(OP2-1)
     cp (hl)
     jr z,TypeMatch
       add hl,bc
       ld c,(hl)
       inc c
       inc b
       or a
       sbc hl,bc
       jr CompareLoop
NotMatch:
   pop af
   or a
   sbc hl,bc
   jr CompareOverLoop
TypeMatch:
     add hl,bc
     push hl
     ld a,(OP2-2)
     ld c,(hl)
     dec hl
     inc b
     cp c
     jr nz,NotMatch
     inc de
CompareName:
     ld a,(de)
     inc de
     cpd
     jr nz,NotMatch
     jp pe,CompareName
FoundVar:
     pop hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld e,(hl)
     inc hl
     inc hl
     inc hl
     ld a,(hl)
     ret
Digit3:
     ld hl,(ArgLoc)
     ld bc,-6
     add hl,bc
     ld a,(hl)
     and $F0
     ret
Lowercase:
     call Digit3
     jr nz,$+7
       set 3,(iy+36)
       ret
     dec a                  ;1-lowercase on
     jr nz,$+7
       res 3,(iy+36)
       ret
     dec a                  ;2-toggle lowercase
     ret nz
       ld a,8
       xor (iy+36)
       ld (iy+36),a
       ret
GVPutSS:
      ld (textRow),bc
GVPutS:
;===============================================================
;Inputs:
;     HL points to a zero terminated string to display
;     (textRow) is the pixel row to draw at
;     (textCol) is the text column to draw at (0 to 23)
;Outputs:
;     HL points to the ending byte
;     BC is the size of the string
;     A is 0
;     z flag is set
;     c flag reset
;Destroys:
;     DE
;===============================================================
       ld d,0
       ld bc,0
       ld a,(hl) \ cp d \ ret z
       push de
       inc bc \ push bc
       inc hl
       push hl
       ld b,a
       call VPutSC
       pop hl
       pop bc
       pop de
       jr GVPutS+5
VPutSC:
;Inputs:
;    B is the char to draw
     ld hl,9340h
     ld (TempWord5),hl
     ld a,b
     ld hl,BatLibFont
     ld c,b
     ld b,0
     add hl,bc
     add hl,bc
     add hl,bc
     ld de,8483h
     ld b,3
       ld a,(hl)
       and $F0
       ld (de),a
       inc e
       ld a,(hl)
       rrca \ rrca
       rrca \ rrca
       and $F0
       ld (de),a
       inc e
       inc hl
       djnz $-15
     ld ix,8483h
     ld hl,0604h
     jr VputSCStepIn
VPutC:
;Inputs:
;    B is the char to draw
       ld hl,9340h
       ld (TempWord5),hl
       ld hl,(FontPointer)
       ld de,254
         inc e \ inc e
         add hl,de
         ld e,(hl)
         djnz $-4
       ld d,e \ inc hl
       ld e,(hl) \ inc hl
       ex de,hl
VputSCStepIn:
       push hl
       ld bc,(textRow)
       ld a,b \ add a,l
       cp 97
       jr c,geykley
         ld a,c
         add a,h \ ld c,a
         ld a,l \ ld b,0
geykley:
       ld l,a
       ld a,c
       cp 58
       jr c,gerkeb
         xor a
         ld c,a
gerkeb:
       ld h,l
       ld l,a
CoordAdj:
       ld (textRow),hl

       pop hl
       push ix
       pop de
; jr $
     ld ix,(TempWord5)
     di
     push hl
     ld a,b
     ld b,0
     ld h,b \ ld l,c
     add hl,hl \ add hl,bc
     add hl,hl \ add hl,hl
     push hl
     ld c,a
     srl c \ srl c \ srl c
     ld b,0
     add ix,bc
     pop bc

     add ix,bc
     push ix
     and 7
     ld (TempWord1),a
     exx
     pop hl
     ld bc,11
     exx
     pop bc
DrawSpriteOR:
       ld a,(de)
       inc de
       exx
       ld d,0 \ ld e,a

     ld a,(TempWord1)
     or a \ jr z,EndShiftDE
     ld b,a
       rr e \ rr d
       jr nc,$+4
         set 7,e
       djnz $-8
EndShiftDE:
       ld a,e
       or (hl) \ ld (hl),a
       inc hl
       ld a,d
       or (hl) \ ld (hl),a
       add hl,bc
       exx
       djnz DrawSpriteOR
       ret
IPopUp:
     pop hl
     call PopUp
     ld de,(TempWord4)
     push de
     ret
PopUp:
;Input:
;     HL points to the menu data
;        .db y,x,w
;        .db HeaderHeight
;        .db "Header",0
;        .db #OfItems
;        .db "Item1",0
;        .db "Item2",0
;        .db "Item3",0
;        ...
;        etc.
;Output:
;     H is the number of items
;     L is the selected item
     ld de,9340h
     ld (TempWord5),de
     ld c,(hl)
     inc hl
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld a,6
     push bc
     push de
     push hl
     call DrawRectToGraph
     pop hl
     pop de
     pop bc
     ld b,e
     inc b
     inc b
     inc c
     inc c
     push de
     push bc
     call GVPutSS
     inc hl
     pop bc
     pop de
     ld a,c
     add a,8
     ld c,a
     push bc
     ld a,(hl)
     ld (TempWord3),a
     inc hl
     push af
     ld b,a
     add a,a
     add a,b
     add a,a
     ld b,a
     inc b
     inc b
     inc b
     dec c
     dec c
     ld a,6
     push hl
     push bc
     push de
     call DrawRectToGraph
     pop hl
     dec h
     dec h
     inc l
     ld (TempWord1),hl
     pop hl
     ld h,7
     inc l
     ld (TempWord2),hl
     pop hl
     pop af
     pop bc
     or a
     ret z
     ld de,(TempWord2)
     push de
     ld de,(TempWord1)
     push de
DispPopUpBody:
       push af
       push bc
       call GVPutSS
       inc hl
       pop bc
       ld a,c
       add a,6
       ld c,a
       pop af
       dec a
       jr nz,DispPopUpBody
     pop bc
     ld (TempWord1),bc
     pop bc
     ld (TempWord4),hl
SelectPopUpOption:
     ld bc,(TempWord2)
     ld hl,(TempWord3-1)
     ld l,0
;L is the current selected option
;H is the number of options
SPUO0:
     call PauseWhileKey
     push hl

     ld de,(TempWord1)
     push bc
     ld a,2
     call DrawRectToGraph
     pop bc

     push bc
     call DispGraph
     pop bc

     ld de,(TempWord1)
     push bc
     ld a,2
     call DrawRectToGraph

     call CheckStatus
     ld a,9
     call nz,TwoKeys
     or a
     jr z,$-9
     pop bc
     pop hl
     cp 9
     ret z
     dec a
     jr nz,$+5
       inc a
       jr $+7
     sub 3
     jr nz,SPUO0    
     dec a
     ld d,a
     add a,l
     cp h
     jr nc,SPUO0
     ld l,a
     ld a,d
     add a,a
     add a,d
     add a,a
     add a,c
     ld c,a
     jp SPUO0
;===============================================================
CheckStatus:
;===============================================================
;Speed:  89 cycles
;Size:   13 bytes
;Outputs:
;     z is set if ON is being pressed
;     c is set if 15MHz mode is used
;===============================================================
          push bc             ;C5        11
          push af             ;F5        11
          in a,(4)            ;DB04      11
          and 8               ;E608       7      Check [on]
          in a,(20)           ;DB20      11
          rra                 ;1F         4      c if 15MHz
          pop bc              ;C1        10
          ld a,b              ;78         4
          pop bc              ;C1        10
          ret                 ;C9        10
PauseKey:
     call PauseWhileKey
     call PauseForKey
PauseWhileKey:
     ei
       halt
       xor a
       out (1),a
       in a,(1)
       inc a
       jr nz,$-7
     di
     ret
PauseForKey:
     ei
     halt
     out (1),a
     in a,(1)
     inc a
     jr z,$-6
     di
     ret


;===============================================================
BatLibFont:    ;Used in Grammer as well
;===============================================================
;00~7F
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$8C,$EC,$80,$00,$00,$00,$00,$00,$00
.db $24,$44,$20,$0A,$4A,$00,$00,$EA,$E0,$00,$4E,$40,$00,$04,$00,$00,$E4,$44,$E4,$2C,$00,$EC,$EC,$C0

.db $65,$5C,$40,$62,$A2,$00,$C2,$4E,$00,$02,$48,$E0,$69,$96,$00,$AC,$88,$00,$E4,$40,$00,$68,$60,$E0
.db $2E,$4E,$80,$C2,$C0,$E0,$06,$00,$00,$E8,$C8,$E0,$42,$F2,$40,$AD,$DD,$A0,$4E,$44,$40,$44,$4E,$40

.db $00,$00,$00,$44,$40,$40,$AA,$A0,$00,$00,$00,$00,$00,$00,$00,$A2,$48,$A0,$4A,$4A,$50,$88,$80,$00
.db $24,$44,$20,$84,$44,$80,$00,$40,$00,$04,$E4,$00,$00,$44,$80,$00,$E0,$00,$00,$00,$80,$22,$48,$80

;FontNumbers
.db $4A,$AA,$40,$4C,$44,$E0,$C2,$48,$E0,$C2,$42,$C0,$AA,$E2,$20,$E8,$C2,$C0,$68,$EA,$E0,$E2,$44,$40,$EA,$EA,$E0,$EA,$E2,$20

;3Ah~3Fh
.db $04,$04,$00,$04,$04,$80,$24,$84,$20,$0E,$0E,$00,$84,$24,$80,$C2,$40,$40

.db $00,$00,$00,$4A,$EA,$A0,$CA,$CA,$C0,$68,$88,$60,$CA,$AA,$C0,$E8,$C8,$E0,$E8,$C8,$80,$68,$AA,$60
.db $AA,$EA,$A0,$E4,$44,$E0,$62,$2A,$40,$AA,$CA,$A0,$88,$88,$E0,$AE,$AA,$A0,$CA,$AA,$A0,$EA,$AA,$E0
.db $CA,$C8,$80,$EA,$AE,$60,$CA,$CA,$A0,$68,$42,$C0,$E4,$44,$40,$AA,$AA,$E0,$AA,$AA,$40,$AA,$AE,$A0
.db $AA,$4A,$A0,$AA,$44,$40,$E2,$48,$E0,$4A,$EA,$40,$88,$42,$20,$C4,$44,$C0,$4A,$00,$00,$00,$00,$E0
.db $84,$00,$00,$06,$AA,$60,$88,$CA,$C0,$06,$88,$60,$22,$6A,$60,$04,$AC,$60,$48,$C8,$80,$06,$A6,$2C
.db $88,$CA,$A0,$40,$44,$40,$20,$22,$A4,$8A,$CA,$A0,$88,$88,$40,$0A,$EA,$A0,$0C,$AA,$A0,$04,$AA,$40
.db $0C,$AC,$80,$06,$A6,$22,$0A,$C8,$80,$0C,$84,$C0,$4E,$44,$20,$0A,$AA,$E0,$0A,$AA,$40,$0A,$AE,$A0
.db $0A,$44,$A0,$0A,$A6,$24,$0E,$24,$E0,$64,$84,$60,$44,$44,$40,$C4,$24,$C0,$05,$A0,$00,$E0,$E0,$E0

;FontNumbers2
.db $04,$AA,$A4,$04,$C4,$4E,$0C,$24,$8E,$0C,$24,$2C,$0A,$AE,$22,$0E,$8C,$2C,$06,$8E,$AE,$0E,$24,$44
.db $0E,$AE,$AE,$0E,$AE,$22

;Accented A
.db $24,$AE,$A0,$84,$AE,$A0,$00,$00,$00,$A4,$AE,$A0

;Accented a
.db $24,$06,$A5,$42,$06,$A5,$4A,$06,$A5,$A0,$6A,$60

;Accented E
.db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00

;Accented e
.db $48,$4A,$C6,$42,$4A,$C6,$4A,$4A,$C6,$A0,$4A,$C6

;Accented I
.db $24,$0E,$4E,$84,$0E,$4E,$4A,$0E,$4E,$A0,$E4,$E0

;Accented i
.db $24,$04,$44,$84,$04,$44,$4A,$04,$44,$A0,$44,$40

;Bombs... er, accented O
.db $24,$69,$96,$84,$69,$96,$4A,$69,$96,$A0,$69,$96

;Lowercase bombs
.db $24,$06,$96,$84,$06,$96,$4A,$06,$96,$A0,$06,$96

;Accented U
.db $24,$AA,$A6,$84,$AA,$A6,$4A,$AA,$A6,$A0,$AA,$A6

;Accented u
.db $24,$0A,$A6,$84,$0A,$A6,$4A,$0A,$A6,$A0,$0A,$A6

;Accented C,c,N,n
.db $4A,$8A,$48,$06,$88,$6C,$5A,$0C,$AA,$5A,$0C,$AA

;Other Puntuation
.db $24,$00,$00,$84,$00,$00,$A0,$00,$00,$40,$48,$60

;Upside-Down Exclamation Point Identical to lowercase i
;Change to something else?
.db $00,$00,$00

;Greek
.db $05,$AA,$50,$25,$65,$A0,$05,$A2,$20,$00,$4A,$E0,$34,$27,$96,$68,$E8,$60

;[
.db $64,$44,$60

;Greek (continued)
.db $84,$25,$90,$0A,$AD,$80,$0F,$55,$90,$25,$56,$48,$F4,$24,$F0
.db $07,$55,$40,$07,$A2,$10
;Idunno howta do these
.db $4E,$AE,$40,$69,$99,$69

;CC~CF
.db $E0,$A4,$A0,$E0,$A6,$24,$52,$50,$00,$00,$00,$A0,$26,$E6,$20

;D0~D5
.db $44,$40,$00,$22,$48,$80,$00,$60,$00,$C4,$8C,$00,$EA,$E0,$00,$E4,$2C,$00

;D6
.db $00,$00,$00

;D7~DF
.db $40,$44,$20,$04,$CA,$C8,$8A,$4A,$20,$E9,$AE,$A8,$69,$E8,$60,$00,$44,$60,$9D,$FB,$90,$A5,$55,$A0,$4E,$FE,$40

;Overwrite Cursor
.db $FF,$FF,$FF,$FB,$1B,$BF,$FB,$51,$5F,$FF,$95,$9F

;Insert Cursor
.db $00,$00,$0F,$4E,$EE,$0F,$4A,$EA,$0F,$06,$A6,$0F

;E8~EF
.db $00,$84,$20,$00,$C6,$20,$00,$E6,$20,$00,$8C,$E0,$25,$D5,$20,$4A,$AA,$40,$4E,$44,$40

;F0~F4
.db $44,$4E,$40,$5A,$5A,$5A,$27,$A6,$3E,$4E,$44,$00,$69,$A9,$A0

;male/female
.db $73,$5E,$AE,$EA,$E4,$E4

;BlockEater Down	$F7
.db $6F,$96,$90
;BlockEater Left        $F8
.db $6F,$16,$90
;BlockEater Right       $F9
.db $6F,$86,$90
;BlockEater Up          $FA
.db $69,$96,$90

;FB~FE
.db $09,$AC,$E0,$08,$53,$70,$EC,$A1,$00,$73,$58,$00

;FF
.db $A5,$A5,$A5
;===============================================================
DispGraphBuffer:
DispGraph:
;===============================================================
     ld hl,9340h
;===============================================================
BufferToLCD:
;===============================================================
;Input:
;     HL points to the buffer to copy to the LCD
;Outputs:
;
;===============================================================
     di
setrow:
     LCDDelay()
     ld a,$80
     out (16),a
     ld de,12
     ld a,$20
col:
     ld b,a
     LCDDelay()
     ld a,b
     out (10h),a
     push af
     ld b,64
row:
     ld a,(hl)
     add hl,de
     bit 3,(iy+5)
     jr z,$+3
       cpl
     ld c,a
     LCDDelay()
     ld a,c
     out ($11),a
     djnz row

     pop af
     inc a
     dec h
     dec h
     dec h
     inc hl

     cp $2c
     jp nz,col
     ret
;===============================================================
TwoKeys:
;017F07210000545DCB0179D301E3E3DB012FB720083E08856F10ED180EC506082C0F30025C6510F8C110DD7CB720016F6C627BB7280A444D2909290929292909197DC9
;4 bytes optimised from the original
;Outputs:
;      A is the lower 8-bits of the keypress
;     HL is the 16-bit keycode for two key presses
;===============================================================
     ld bc,077Fh
     ld hl,0
     ld d,h
     ld e,l
       rlc c
       ld a,c
       out (1),a
       push hl
       pop hl
       in a,(1)
       cpl
       or a
       jr nz,$+10
       ld a,8
       add a,l
       ld l,a
       djnz $-17
       jr $+16
       push bc
       ld b,8
       inc l
       rrca
       jr nc,$+4
         ld e,h
         ld h,l
       djnz $-6
       pop bc
       djnz $-33
       ld a,h
       or a
       jr nz,$+3
         ld l,a
     ld l,h
     ld h,d
     ld a,e
     or a
     jr z,$+12
       ld b,h
       ld c,l
       add hl,hl
       add hl,bc
       add hl,hl
       add hl,bc
       add hl,hl
       add hl,hl
       add hl,hl
       add hl,bc
       add hl,de
     ld a,l
     ret
DE_Div_BC:
     ex de,hl
HL_Div_BC:
     ld a,16
     ld de,0
       add hl,hl
       ex de,hl
       adc hl,hl
       or a
       sbc hl,bc
       jr nc,$+5
         inc e
       jr $+3
       add hl,bc
       ex de,hl
       dec a
       jr nz,$-15
       ret
HL_Times_BC:
     ex de,hl
DE_Times_BC:
     ld hl,0
     ld a,16
       add hl,hl
       rl e
       rl d
       jr nc,$+3
       add hl,bc
       dec a
       jr nz,$-9
     ret
MakeAnsStrX:
     ld h,b
     ld l,c
MakeAnsStrHL:
     ld a,l
     or h
     jp z,NO_DATA
     push hl
     bcall(4324h)
     inc de
     inc de
     push de
     call COP4toOP2
     pop de
     pop bc
     ret
DeTokFSStr:
;Inputs:
;     HL points to the string
;     BC is the size
;Outputs:
;     DE is the new string size
;     HL remains the same
     push hl
     pop ix
     push hl
     push bc
     ld de,0
DeTokLoop:
     ld a,(hl)
     cp $BB
     jr nz,WriteDeTokdByte
       inc hl \ dec bc
       ld a,(hl)
       cp 6Eh
       jr nc,$+11
         ld (ix),$BB
         inc ix
         inc de
         jr WriteDeTokdByte
       push hl
       push bc
       push de
       dec hl
       bcall(4594h)
       ld a,(848Eh)
       pop de
       pop bc
       pop hl
WriteDeTokdByte:
     ld (ix),a
     inc ix
     inc de
     cpi
     jp pe,DeTokLoop
     ld (StrSize),de
;resize the string
;IX is where to delete
     pop hl       ;original size
     or a
     sbc hl,de    ;number of bytes to delete
     ex de,hl
     push ix
     pop hl
     jr z,$+5
     bcall(_DelMem)
     ld de,(StrSize)
     pop hl
     dec hl
     ld (hl),d
     dec hl
     ld (hl),e
     inc hl
     inc hl
     ret
TokenToASCII:
;Input:
;    HL points to the start of the string
;    B is the size of the string
;Outputs:
;     A is zero
;    BC is the size of the string
;    DE points to the start of the converted string
;    HL points to the ending byte of the string
;     z flag is set
        ld a,b
        ld bc,0              ;010000
        or a
        ret z
TextConvert:
          push af
          ld a,(hl)            ;7E
          call TokToASCII+3
        ex (sp),hl
        jr nz,$+4
        dec h \ ret z
        ex (sp),hl
          pop af
          dec a
          jr nz,TextConvert
     inc hl
     ret
     ld de,848Eh
TokToASCII:
;Inputs:
;     HL points to the token
;     DE points to where the token should get converted to
;Outputs:
;     HL is incremented
;     DE points to the byte after the string 
;     BC is the size of the string
     ld bc,0
     push hl
     push bc
     push de
     bcall(4594h)
     pop de
     pop hl
     add hl,bc
     push hl
     ld hl,848Eh
     ldir
     pop bc
     pop hl
     ld a,(hl)            ;7E
     call Is_2_Byte
     inc hl
     ret nz
     inc hl
     ret
GetName:
     call LoadInc
     cp 12
     jp nc,BAD_NUMBER
     ex de,hl
     add hl,hl
     ld de,VarTypes
     add hl,de
     ld e,(hl)
     inc hl
     ld d,(hl)
     push de
     call LoadInc
     ld b,d
     ld c,e
     ld a,255
     ld (847Ah),a
     pop hl
     ld (8478h),hl
     inc bc
       push bc
       bcall(_FindAlphaUp)
       pop bc
       jp c,DNE
       dec bc
       ld a,b
       or c
       jr nz,$-11
;OP1 contains the name
NameToTokString:
     ld hl,8478h
     ld c,3
     ld a,(hl)
     and 1Fh
     push af
     add a,40h
     ld (hl),a
     cp 41h
     jr nz,$+18
CheckListName:
       push hl
       inc hl
       inc hl
       ld a,(hl)
       cp 6
       jr c,$+9
         dec hl
         ld (hl),$EB
         dec hl
         call OP1Length
       pop hl
     pop af
     cp 4Dh
     jr z,CheckListName
     or a
     jr nz,$+3
     dec c
     cp 12
     jr nz,$+3
     dec c
     cp 5
     call z,OP1Length
     cp 6
     call z,OP1Length
     cp 14h
     call nc,OP1Length
;     cp 16h
;     call z,OP1Length
;     cp 17h
;     call z,OP1Length
     ld de,86ECh
     call ASCIIToToken
;BC is the size of the new string
;DE points to the new string
;HL is the size, too
     push de
     call MakeAnsStrHL
     pop hl
     ldir
     ret
OP1Length:
     push hl
     push af
     xor a
     ld c,9
     cpir
     jr nz,$+3
       inc c
     ld a,9
     sub c
     ld c,a
     pop af
     pop hl
     ret
VarTypes:
 .db 5,0      ;Program
 .db 21,0     ;Appvar
 .db 22,0     ;TempProg
 .db 4,255    ;string
 .db 7,255    ;pic
 .db 8,255    ;gdb
 .db 23,0     ;group
 .db 2,255    ;matrix
 .db 3,255    ;equation
 .db 0,0      ;real num
 .db 12,0     ;complex num
 .db 1,255    ;list
ASCIIToToken:
;Inputs:
;     HL points to the string
;     DE points to the output
;     BC is the size of the input
;Outputs:
;     BC is the size of the new string
;     DE points to the new string
;     HL is the size, too
     push de
     call ConvToTok
     pop hl
     ex de,hl
     or a
     sbc hl,de
     ld b,h
     ld c,l
     ret
funcGETF:
;     GETF(path,field#)
     call OpenFolder
     jp c,NDStr
     push de
     call ConvRStr8
     ld a,e
     pop hl
     call FindField
     jp c,NDStr
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl                ;don't need to worry if BC is zero
     push  hl
     push bc
     call GetTokenisedSize
     call MakeAnsStrX
     pop bc
     pop hl
;BC is the size of the string
;DE points to Ans
ConvToTok:
;Inputs:
;     HL points to the ascii string
;     DE points to the output
;     BC is the size of the input
;Outputs:
;     BC is 0
;     DE points to the end of the new string
;     HL points to the end of the ASCII string
     call Is_Lowercase
     jr nc,$+14
       ex de,hl
       ld (hl),$BB
       inc hl
       ex de,hl
       add a,4Fh
       cp BBh
       jr c,$+3
         inc a
     cp 2Eh
     jr nz,$+4
       ld a,3Ah
     cp 20h
     jr nz,$+4
       add a,9
     cp 3Fh
     jr nz,$+3
       dec a
     ld (de),a
     inc de
     cpi
     jp pe,ConvToTok
     ret
Is_Lowercase:
     ld a,(hl)
     cp 7Bh
     ret nc
     cp 61h
     ccf
     ret
Coordinates:
     call LoadInc
     push de
     call LoadInc
     ld h,d
     ld l,e
     add hl,hl
     add hl,de
     add hl,hl
     add hl,hl
     pop de
     add hl,de
     ret
ConvDSprite:
     push bc
     push hl
     ld hl,86ECh
     push hl
     ex de,hl
     ld a,c
     push af
     push hl
     push bc
       ld a,(hl)
       ld (de),a
       inc de
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-8
       pop bc
       pop hl
       pop af
       inc hl
       dec a
       jr nz,$-18
       pop de
       pop hl
       pop bc
       ret
LocateStr1:
     ld bc,00AAh
     call SearchVarBC
     jp c,HardExit
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ex de,hl
     ret
CorrectOffset:
     or a
     ret z
     push bc
     ld b,a
     ld a,h
     sub 40h
     rlca
     rlca
     and 3
     add a,b
     ld b,a
     ld a,h
     and 63
     add a,40h
     ld h,a
     ld a,b
     pop bc
     ret
NumStr:
     ld de,(ArgLoc)
     call FPToStr
     ld (ArgLoc),de
     ld hl,(ArgCount)
     ld a,h
     or l
     jr z,$+6
     dec hl
     ld (ArgCount),hl
     call MakeAnsStrX
     ld hl,86ECh
     ldir
     ret
ListNumStr:
     call ListOrName
     jp nz,BAD_INPUT
     ld (TempWord4),hl
     push bc
     ld hl,1
     call MakeAnsStrHL+5
     ex de,hl
     ld (hl),8
     inc hl
     ld (TempWord1),hl    ;pointer to where to insert the next data
     dec hl
     dec hl
     dec hl
     ld (TempWord2),hl    ;pointer to the sizebytes
     ld (TempWord3),bc    ;size of the string
     pop bc
     jr $+10
ListToNumLoop:
     ld a,2Bh
     ld (de),a
     inc de
     ld (TempWord1),de

     ld de,(TempWord4)
     dec bc
     ld a,b
     or c
     push bc
     push af
     call FPToStr
     ld (TempWord4),de
     pop af
     push af
     push bc
     ld hl,(TempWord3)
     jr z,$+3
     inc bc
     add hl,bc
     ld (TempWord3),hl
     ld d,b
     ld e,c
     ld b,h
     ld c,l
     ld hl,(TempWord2)
     ld (hl),c
     inc hl
     ld (hl),b
     ex de,hl
     bcall(42FDh)       ;EnoughMem
     jp c,TOO_BIG
     ld hl,(TempWord1)
     ex de,hl
     push de
;hl is # of bytes
;de is location
     bcall(42F7h)
     pop de
     pop bc
     ld hl,86ECh
     ldir
     pop af
     pop bc
     jr nz,ListToNumLoop
     ret
FPToStr:
;Inputs:
;     DE points to the FP number
;
     ld hl,86ECh
     ld a,(de)
     bit 7,a
ImaginaryStepIn:
     push af               ;still need to check if it is imaginary
     jr z,$+5
     ld (hl),$B0
     inc hl                ;I would do 'inc l', normally
     inc de
     ld a,(de)
     ex de,hl
     sub 80h
     ld b,a
     inc hl
     push de
     jp c,LeadingZeroes
     inc b
     ld a,15
     sub b
     ld c,a
     ld a,30h
ConvFPLoop:
       rld
       ld (de),a
       inc de
       rrd
       djnz $+4
       jr AddDecimal
       rrd
       ld (de),a
       inc de
       rld
       inc hl
       djnz ConvFPLoop
AddDecimal:
     ld a,3Ah
     ld (de),a
     inc de
     ld b,c
     srl b
     jr nc,StepHalf
ConvFPLoop2:
       rld
       ld (de),a
       inc de
       rrd
StepHalf:
       rrd
       ld (de),a
       inc de
       rld
       inc hl
       djnz ConvFPLoop2
EndingZeroes:
     pop bc
;DE points to the FP number
;HL points to the string
;BC points to the start of the string
     push hl
     ex de,hl
     push hl
     or a
     sbc hl,bc
     ld b,h
     ld c,l
     pop hl

     ld a,30h
     dec hl
       cpd
       jp po,$+5
       jr z,$-5
     pop de
     inc hl
     ld a,(hl)
     cp 3Ah
     jr z,$+4
       inc hl
       inc c
     pop af
     jr z,$+3
     inc c
;BC is the size of the string
;DE has been incremented by 9
;HL points to the end of the string
     and 8
;     bit 3,a           ;Check if it is imaginary
     ret z
     ld a,(de)
     add a,a
     ld a,38h
     adc a,a           ;same as rla
     ld (hl),a
     inc hl
     ld a,b
     or b
     jr nz,GetImagPart
     or c
     dec a
     jr nz,GetImagPart
       dec hl
       dec hl
       ld a,(hl)
       cp 30h
       jr z,$+6
         inc hl
         inc hl
         jr GetImagPart
       dec bc
       dec bc
GetImagPart:
     push bc
     push af
     xor a
     call ImaginaryStepIn
 dec hl
 pop af
 jr nz,$+10
   ld a,(hl)
   sub 31h
   jr nz,ImagPart
   dec c
   jr ImagPart+1
 dec hl
 ld a,(hl)
 and -2
 cp 70h
 inc hl
 jr nz,ImagPart
 ld a,(hl)
 sub 30h
 jr nz,$+5
   dec hl
   pop bc
   ret
 dec a
 jr nz,$+5
   dec c
   jr $+3
ImagPart:
 inc hl
     ld (hl),2Ch
     inc hl
     ex (sp),hl
     add hl,bc
     ex (sp),hl
ImagPartIs0:
     pop bc
     inc bc
     inc bc
     ret
LeadingZeroes:
     ld a,3Ah
     ld (de),a
     inc de
     ld a,30h
       inc b
       jr z,$+6
       ld (de),a
       inc de
       jr $-5
     ld b,7
     jp ConvFPLoop2
CompressStr:
     call LoadInc
     ld hl,Codec1
     dec a
     jr nz,$+5
     ld hl,Codec2
     jr $+5
CompData:
     call CustCodec
     ld (TempWord2),hl
     call StringOrName
     ld (TempWord1),hl
     push bc
     push af
     push hl
     inc bc
     inc bc
     call MakeAnsStrX
     pop hl
     pop af
     pop bc
     ex de,hl
     ld (hl),c
     inc hl
     ld (hl),b
     inc hl
     ex de,hl
     push bc
     push de
     call ReadArc
     pop hl
     pop bc
     push hl
     push de
     ld de,(TempWord1)
     ld ix,(TempWord2)
     call TextComp
     pop de
     inc hl
;HL points to the end of where it was converted
     ex de,hl
     or a
     sbc hl,de
     ex de,hl
;DE is the size of the data to delete
;HL points to where to delete the data
     push hl
     bcall(4357h)
     pop hl
     pop de
     dec de
     dec de
     or a
     sbc hl,de
     ex de,hl
     dec hl
     ld (hl),d
     dec hl
     ld (hl),e
     ret

TextComp:
;Inputs:
;     DE points to the text to convert
;     HL points to where to convert to
;     BC is the size of the string
;     IX points to the codec
     call CodecStats
     ld (8478h),bc
     ld b,0
     ld (hl),0
TextCompLoop:
     push hl
     push bc
     ld bc,(8478h)
     ld a,b \ or c
     jr nz,$+11
       pop bc
       pop hl
       bit 0,b
       ret z
       xor a
       rld
       ret
     dec bc
     ld (8478h),bc
     ld a,(de)
     inc de
     ld c,(ix)
     push ix
     pop hl
     inc hl
     cpir

     push hl
     push af
     ld a,(ix)
     dec a
     ld h,a
     pop af
     ld a,h
     pop hl
     
     jr z,$+3
       ld c,a
     sub c
     pop bc
     pop hl
     exx
     cp c
     exx
     jr c,$+23
     exx
     sub b
     exx
     rlca \ rlca \ rlca \ rlca
     rld
     rlca \ rlca \ rlca \ rlca
     inc b
     bit 0,b
     jr nz,$+4
       inc hl
       ld (hl),0
     rld
     inc b
     bit 0,b
     jr nz,TextCompLoop
     inc hl
     jr TextCompLoop-2
Codec1:
;46 chars
; ETAOINSHRDLCUMFGYPBVKWXJQZ,?!.0123456789/-:'
 .db Codec1End-Codec1
 .db 29h,"ETAOINSHRDLCUMFGYPBVKWXJQZ",2Bh
 .db $AF,2Dh,3Ah,"0123456789",83h,71h,3Eh,$AE
Codec1End:
Codec2:
;46 chars
; ETAOINSHRDLCUMFGYPBVKWXJQZ,?!.0123456789/-:"'
 .db Codec2End-Codec2
 .db $29,$BB,$45,$B4,$54,$C4,$41,$B0,$4F,$BF,$49,$B8,$4E,$BE,$53,$C3,$48,$B7,$52,$C2,$44,$B3,$4C,$BC
 .db $43,$B2,$55,$C5,$4D,$BD,$46,$B5,$47,$B6,$59,$C9,$50,$C0,$42,$B1,$56,$C6,$4B,$BA,$57,$C7,$58,$C8
 .db $4A,$B9,$51,$C1,$5A,$CA,$2B,$AF,$2D,$3A,$30,$31,$32,$33,$34,$35,$36,$37,$38,$39,$83,$71,$3E,$AE
;need 4 more bytes
 .db 3Fh,82h,70h,$B0
Codec2End:
CustCodec:
     call StringOrName
     ld de,86ECh
     push de
     call ReadArc
     pop hl
     ret
DeCompStr:
     call LoadInc
     ld hl,Codec1
     dec a
     jr nz,$+5
     ld hl,Codec2
     jr $+5
DeCompData:
     call CustCodec
     ld (TempWord2),hl
     call StringOrName
     or a
     jp nz,ARCH
     dec bc
     dec bc
     push bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     push hl
     inc bc
     call MakeAnsStrX
     ld (TempWord1),bc
     pop hl
     pop bc
     push de
     ld ix,(TempWord2)
     call TextDeComp
;DE is the size of the data to delete
;HL points to where to delete the data
     ex de,hl
     ld de,1
     bcall(4357h)
     pop hl
     dec hl
     dec hl
     ld a,(hl)
     dec a
     ld (hl),a
     inc a
     ret nz
     inc hl
     dec (hl)
     ret
CodecStats:
;     IX points to the codec
;        codec format is the first byte is the size, followed by the bytes allowed
;Output:
;     B' is the adjusting value for one-byte values
;     C' is the cut-off for half-byte values
;     A is the same as B'
     di
     exx
     ld a,(ix)
     rlca
     rlca
     rlca
     rlca
     and 15
     ld b,a
   ld a,(ix)
   and 15
   add a,b
   and 240
   jr z,$+3
   inc b
     ld a,16
     sub b       ;
     ld c,a      ;number of half nibbles
     ld a,b
     rlca
     rlca
     rlca
     rlca
     or c
     ld b,a
     exx
     ret
TextDeComp:
;Inputs:
;     HL points to the text to decompress
;     DE points to where to convert to
;     BC is the size of the string
;     IX points to the codec
     call CodecStats
     ld (8478h),bc
     ld b,0
TextDeCompLoop:
     call GetNextNibble
     ld a,c
     exx
     cp c
     exx
     jr c,$+15
       ld (de),a
       call GetNextNibble
       ld a,(de)
       rlca \ rlca \ rlca \ rlca
       or c
       exx
       add a,b
       exx
     push hl
     push ix
     pop hl
     inc hl
     add a,l
     jr nc,$+3
     inc h
     ld l,a
     ld a,(hl)
     pop hl
     ld (de),a
     inc de
     push bc
     ld bc,(8478h)
     ld a,b \ or c
     pop bc
     jr nz,TextDeCompLoop
     ret
GetNextNibble:
; z flag set if the last 
     xor a
     inc b
     bit 0,b
     jr z,$+8
     rld
     ld c,a
     rrd
     ret
     rrd
     ld c,a
     rld
     push bc
     ld bc,(8478h)
     dec bc
     ld (8478h),bc
     pop bc
     inc hl
     ret     
GetCodec:
     call StringOrName
     or a
     ret nz
     or b
     or c
     jp z,NO_DATA
     call CountBytes
     call MakeAnsStrX
     dec bc
     ld a,c
     ld (de),a
     inc de
     ld hl,88ECh
     ldir
     ret
CountBytes:
     push hl
     push bc
     xor a
     ld hl,86ECh
     ld (hl),a
     ld d,h
     ld e,l
     inc de
     ld bc,2FFh
     ldir
     pop bc
     pop hl
GetCodecLoop:
     push bc
     ld e,(hl)
     ld d,0
     ex de,hl
     add hl,hl
     ld bc,86ECh
     add hl,bc
     inc (hl)
     jr nz,$+4
     inc hl
     inc (hl)
     ex de,hl
     pop bc
     cpi
     jp pe,GetCodecLoop
     call Order
     ld b,0
     inc bc
     ret
Order:
     di
     ld hl,86ECh     ;points to the density list (512 bytes)
     ld de,88ECh     ;points to where the output is
     ld bc,0
     ld (TempWord1),hl
     exx
     ld hl,0         ;MaxVal
     exx
OrderLoop:
     push bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     push bc
     exx
     pop de
     or a
     sbc hl,de
     add hl,de
     jr nc,$+3
       ex de,hl
     exx
     pop bc
     djnz OrderLoop
     ld hl,(TempWord1)
     exx
     ld a,h
     or l
     exx
     ret z
     xor a
OrderLoop1:
     push bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     push bc
     exx
     pop de
     or a
     sbc hl,de
     add hl,de
     exx
     pop bc
     jr nz,$+12
       ld (de),a
       inc de
       ld (hl),0
       dec hl
       ld (hl),0
       inc hl
       inc c
       ret z
     inc hl
     inc a
     djnz OrderLoop1
     ld hl,(TempWord1)
     jr OrderLoop-5
RoundHL_Div_10:
     ld c,10
RoundHL_Div_C:
;Inputs:
;     HL is the numerator
;     C is the denominator
;Outputs:
;     A is twice the remainder of the unrounded value 
;     B is 0
;     C is not changed
;     DE is not changed
;     HL is the rounded quotient
;     c flag set means no rounding was performed
;            reset means the value was rounded
;
       ld b,16
       xor a
         add hl,hl
         rla
         cp c
         jr c,$+4
           inc l
           sub c
         djnz $-7
       add a,a
       cp c
       ret c
       inc hl
       ret
SpeedyKeyHook:
     .db 83h
     ld b,a
     ld hl,8442h
     ld a,(hl)
     cp 50
     jr c,$+8
       ld a,(Delay)
       ld (hl),a
       ld a,b
       ret
     cp 10
     jr nz,$+6
       ld a,(Repeat)
       ld (hl),a
     ld a,b
     ret
;===============================================================
ConvRStr:
;===============================================================
;Input: 
;     DE points to the base 10 number string in RAM. 
;Outputs: 
;     HL is the 16-bit value of the number 
;     DE points to the byte after the number 
;     BC is HL/10 
;     z flag reset (nz)
;     c flag reset (nc)
;Destroys: 
;     A (actually, add 30h and you get the ending token) 
;Size:  35 bytes
;Speed: 106n+109+9c
;       n is the number of digits 
;       c is at most n-2 
;       at most 666 cycles for any 16-bit decimal value 
;===============================================================
     dec hl
     ex de,hl         ;   4 : EB
     ld hl,0          ;  10 : 210000 
ConvLoop:             ; 
     ld a,(de)        ;   7 : 1A 
     sub 30h          ;   7 : D630 
     cp 10            ;   7 : FE0A 
     jr nc,Convtd     ;7|12 : 30**
     inc de           ;   6 : 13 
                      ; 
     ld b,h           ;   4 : 44 
     ld c,l           ;   4 : 4D 
     add hl,hl        ;  11 : 29 
     add hl,hl        ;  11 : 29 
     add hl,bc        ;  11 : 09 
     add hl,hl        ;  11 : 29 
                      ; 
     add a,l          ;   4 : 85 
     ld l,a           ;   4 : 6F 
     jr nc,ConvLoop   ;12|23: 30EE 
     inc h            ; --- : 24 
     jp ConvLoop      ; --- : 18EB
Convtd:
     ld (progPtr),de  ;  20 : ED53****
     ld b,h
     ld c,l
     ret
;============================================
OpenFileSystPath:
     call LocateStr
     ex de,hl
FileSystVarName:
     cpi
     jp po,BAD_NAME
     ld (StrLoc),hl
     call DeTokFSStr
     call LoadWD
     call OpenFolder
Shortcutloop:
     ex de,hl
     push hl
     push de
     inc hl
     ld c,(hl)
     ld b,0
     push bc
     call SkipToInfo+1
     ld a,(hl)
     pop bc
     pop de
     pop hl
     bit 3,a
     jr z,CheckOSVar
       ex de,hl
       call OpenShortCut
       jr Shortcutloop
CheckOSVar:
     rlca
     jr c,OSVarNameInfo
       xor a
       inc hl
       ld c,(hl)
       ld b,a
       dec hl
       ret
OsVarNameInfo:
     push de
     push hl
     call SetTPathAsMain
     pop de
     pop hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld a,(hl)
     scf
     ret
LoadTypevarName:
;BC is the name length
;A is the flash page
;HL points to the type byte
;DE points to the size bytes
     call LocateStr
     ex de,hl
     ld a,(hl)
     cp 10h
     jr nz,$+6
       call FileSystVarName
       ret nc
OSVarInfo:
     ld e,(hl)
     inc hl
     ld a,(hl)
     cp $EB
     ld a,e
     ld de,8478h
     jr nz,CheckVarType
       ld a,1
       ld (de),a
WritingListName:
       ld a,5Dh
       inc e
       ld (de),a
       inc e
       inc hl
       dec c
       dec c
       jr DeTokName
CheckVarType:
     and 31
     ld (de),a
     dec a                    ;1
     jr z,ListName
     sub 4                    ;5
     jr z,DeTokName
     dec a                    ;6
     jr z,DeTokName
     sub 7                    ;13
     jr z,ListName
     sub 7                    ;20
     jr z,AppName
     dec a                    ;21
     jr z,DeTokName
     dec a                    ;22
     jr z,DeTokName
     dec a                    ;23
     jr z,DeTokName
     inc de
     ld a,(hl)
     ldi
     cp 72h
     jr z,$+4
     ldi
     xor a
     ld (de),a
     call FindSym
     dec c
     ld a,b
     ld b,0
     ret
AppName:
     dec hl
     ld b,c
     call TokenToASCII
     bcall(4C4Eh)
     ld de,4000h
     ld b,e
     ld c,e
     ret nc
     jp BAD_NAME
ListName:
     dec hl
     ldir
     ld c,3
     jr PadName
DeTokName:
     ld b,c
     dec b
     inc e
     call TokenToASCII
PadName:
     xor a
     ld (de),a
     inc de
     ld (de),a
     call ChkFindVar
     ld a,b
     ld b,0
     ret
MakeAnsList:
     ld a,d
     or e
     jp z,NO_DATA
     push de
     ex de,hl
     bcall(4312h)
     inc de
     inc de
     push de
     call COP4toOP2
     pop de
     pop bc
     ret
SaveWD:
     .db 1,"WD"
     call SearchVarBC
     inc de
     inc de
     ld hl,DirNest
     ld bc,129
     ldir
     ret
HardExit:
     bit 5,(iy+33)
     call nz,SaveWD
     ld sp,(SPSave)
     call COP2toOP1
     inc c              ;resets the z flag since the previous call returns with BC=0
     ret
HL_Div_10:
     ld c,10
HL_Div_C:
     ld b,16
     xor a
       add hl,hl
       rl a
       cp c
       jr c,$+4
         inc l
         sub c
       djnz $-8
     ret
SetXXXXOP1:
     ld de,8478h
SetXXXXDE:
     push de
     ld bc,090Ah
     xor a
       ld (de),a
       inc de
       djnz $-2
     call ConvNumBase
     ld a,c
     ld b,c
     inc b
     sra b
     add a,7Fh
     pop de
     inc de
     push de
     ex de,hl
     ld (hl),a
     ld a,(de)
     inc de
     inc hl
     rld
     ld a,(de)
     inc de
     rld
     djnz $-9
     pop hl
     ld bc,8
     add hl,bc
     ex de,hl
     ret
COP2toOP1:
     ld hl,8483h
     ld de,8478h
     jr Copy9B
COP4toOP2:
     ld hl,8499h
     ld de,8483h
Copy9B:
     ld bc,9
     ldir
     ret
GetRAMVar:
     call LoadTypevarName
     jp c,BAD_NAME
     or a
     jp nz,ARCH
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ret
MakeAnsMatrix:
     ld a,b
     or c
     jp z,NO_DATA
     ld h,b
     ld l,c
     push bc
     bcall(431Eh)
     inc de
     inc de
     push de
     bcall(411Dh)
     pop de
     pop bc
     ret
PicOrName:
     ld c,60h
     jr StringOrName+2
MatrixOrName:
     ld c,5Ch
     jr StringOrName+2
StringOrName:
     ld c,$AA
     push bc
     ld hl,(ArgLoc)
     ld a,(hl)
     and 1Fh
     pop bc
     jr nz,$+24
       push bc
       call LoadInc
       pop hl
       ld h,a
       ld (8479h),hl
       xor a
       ld (847Bh),a
       call FindSym
       ld a,b
       ld b,0
       dec c
       jp GetStatsArc
     call LocateVar
     ex de,hl
     xor a
     ret
ListOrName:
     ld hl,(ArgLoc)
     ld a,(hl)
     and 31
     jr nz,$+24
       call LoadInc
       ld hl,5D01h
       ld (8478h),hl
       ld (847Ah),de
       call FindVar
       ld a,b
       ld b,0
       jp GetStatsArc
     dec a
     push af
     call LocateVar
     ex de,hl
     pop af
     ret z
     sub 12
     ret z
     add a,9
     jp nz,BAD_NAME

     inc a
     ld de,8478h
     ld (de),a
     ld a,(hl)
     cp $EB
     jr nz,$+8
       inc c
       call WritingListName
       jr $+6
     inc e
     call ListName+1
     jp GetStatsArc
;===============================================================
Is_2_Byte:
;===============================================================
          sub $EF \ ret z        ;ef
          add a,34h \ ret z      ;bb
          add a,3Dh \ ret z      ;7E
Is_Var_Name:
;Before calling this, add 82h to a
          sub 2Ch \ ret z        ;AA
          add a,47h \ ret z      ;63
          inc a \ ret z
          inc a \ ret z
          inc a \ ret z
          add a,2 \ ret z
          inc a \ ret z
          inc a \ ret
ParseString:
GetParseString:
     ld hl,(ArgLoc)
     or a
     jr z,$+3
     cp (hl)
     jp nz,BAD_INPUT
     rst 20h
     ld (ArgLoc),hl
     ld hl,(ArgCount)
     dec hl
     ld (ArgCount),hl
     bcall(42F1h)
     jp c,BAD_INPUT
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ex de,hl
     ret
;===============================================================
GPutS:
;===============================================================
;Inputs:
;     HL points to a zero terminated string to display
;     (textRow) is the pixel row to draw at
;     (textCol) is the text column to draw at (0 to 23)
;Outputs:
;     HL points to the ending byte
;     BC is the size of the string
;     A is 0
;     z flag is set
;     c flag reset
;Destroys:
;     DE
;===============================================================
       ld d,0
       ld bc,0
       ld a,(hl) \ cp d \ ret z
       push de
       inc bc \ push bc
       inc hl
       push hl
       call PutSC
       pop hl
       pop bc
       pop de
       jr GPutS+5
ConvNumbase:
     xor a
     ld de,89EBh
     ld (de),a
     dec de
       call HL_Div_C
       cp 10
       jr c,$+4
       add a,7
       add a,48
       ld (de),a
       dec de
       ld a,h
       or l
       jr nz,$-15
       ld a,$EA
       ld h,b
       sub e
       ld c,a
       inc de
       ex de,hl
       ret
GetLSNAtDE:
     ld a,(de)
     and 15
     inc de
     rld
     ret
RemoveMSNStr:
     call GetLSNAtDE
     call GetLSNAtDE
     cpi
     jp pe,RemoveMSNStr
     ret
;===============================================================
SearchString:
;===============================================================
;Inputs:
;     BC-size of the string
;     DE-points to search string
;     HL-start of search
;Outputs:
;     c flag set if there was a match, nc if no match was found
;     HL points to the match if there was one
;     DE is not changed
;     BC is not changed
;Destroys:
;     A
;===============================================================
     ld ix,-1
     push ix
     di
     exx
     pop bc
     inc b
     inc c
     exx
          ld (TempWord1),bc
          ld (TempWord2),de
SearchStringLoop:
          ld de,(TempWord2)
          ld bc,(TempWord1)
            exx
            dec c
            jr nz,$+3
            dec b
            exx
            jr z,EndOfSearchField
            ld a,(de)           ;1A
            inc de              ;13
            cpi                 ;EDA1
            jr nz,SearchStringLoop
            jp po,MatchedString
            jr SearchStringLoop+8
MatchedString:
     exx
     dec c
     dec b
     push bc
     pop ix
     exx
          ld bc,(TempWord1)
          ld de,(TempWord2)
          scf                 ;37
          ret                 ;C9
EndOfSearchField:
     ld ix,0
     or a
     ret
PutSprite8x8:
     ld b,8
PutSprite8xY
     or a
     jr c,AND8xY-3
OverWrite8xY:
     ld c,12
       ld a,(de)
       ld (hl),a
       inc de
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-8
       ret
     dec a
     jr c,XOR8xY-3
AND8xY:
     ld c,12
       ld a,(de)
       and (hl)
       ld (hl),a
       inc de
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-9
       ret

     dec a
     jr c,OR8xY-3
XOR8xY:
     ld c,12
       ld a,(de)
       xor (hl)
       ld (hl),a
       inc de
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-9
       ret
     dec a
     jr c,Swap8xY-3
OR8xY:
     ld c,12
       ld a,(de)
       or (hl)
       ld (hl),a
       inc de
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-9
       ret

     dec a
     jr c,Erase8xY-3
Swap8xY:
     ld c,12
       ld a,(de)
       ldi
       inc c
       dec hl
       ld (hl),a
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-10
       ret

     dec a
     jr c,Mask8xY-2
Erase8xY:
     ld c,12
       ld a,(de)
       cpl
       and (hl)
       ld (hl),a
       inc de
       ld a,b
       ld b,0
       add hl,bc
       ld b,a
       djnz $-10
       ret

     dec a
     ret nz
Mask8xY:
       ld a,(de)
       and (hl)
       ld c,a
       inc de

       ld a,(hl)
       or c
       ld (hl),a
       inc de

       ld a,b
       ld bc,12
       add hl,bc
       ld b,a
       djnz $-14
       ret
LocateVar:
     xor a
     jr $+8
LocateList:
     ld a,1
     jr $+4
LocateStr:
     ld a,4
     jp ParseString
BAD_NUMBER:
     ld hl,StrErrBadNumber
     ld c,11
     jr MakeErrString
BAD_INPUT:
     ld hl,StrErrBadInput
     ld c,10
     jr MakeErrString
BAD_NAME:
     ld hl,StrErrBadName
     ld c,9
     jr MakeErrString
NO_DATA:
     ld c,8
     ld hl,StrErrNoData
     jr MakeErrString
TOO_BIG:
     ld hl,StrErrTooBig
     ld c,8
     jr MakeErrString
ARCH:
     ld hl,StrErrArch
     ld c,5
     jr MakeErrString
MEM:
     ld hl,StrErrMem
     ld c,4
     jr MakeErrString
BAD_X:
     ld hl,StrErrBadX
     ld c,6
     jr MakeErrString
BAD_Y:
     ld hl,StrErrBadY
     ld c,6
     jr MakeErrString
WIDTH:
     ld hl,StrErrWidth
     ld c,6
     jr MakeErrString
EOFErr:
     ld hl,StrErrEOF
     ld c,4
     jr MakeErrString
DNE:
     ld hl,StrErrDNE
     ld c,4
     jr MakeErrString
HEIGHT:
     ld hl,StrErrHeight
     ld c,7
MakeErrString:
     ld b,0
     push hl
     call MakeAnsStrX
     pop hl
     ldir
     jp HardExit
LoadTSA:
        di
        push af \ push bc \ push de \ push hl
        push ix \ pop hl
        ld c,(hl) \ inc hl
        ld b,(hl) \ inc hl
        ld de,TSA
        ldir
        pop hl \ pop de \ pop bc
        pop af
        ret
SearchLine:
     ld ix,SearchLineData
     jr CallTSA
GetString:
     ld e,63
     xor a
     ld b,a
     ld c,a
GetStringArc:
     ld ix,SearchLineData
     jr CallTSA
ReadArc:
        ld ix,ReadArcData
CallTSA:
        call LoadTSA
        jp TSA
SearchLineData:
     .dw ReadArcData-SearchLineData-2
;Input:
;     A is the flash page to start on
;     BC is the number of bytes left in the file
;     E is the newline byte
;     HL points to start byte
;Output:
;     A is the ending page
;     BC is the number of bytes left
;     DE points to the start of the line
;     HL points to the end of the line
;     pe if the end of the file is not reached
;     po if the EOF is reached
;     z if (hl) is a newline

     out (6),a
     push hl
     ld a,e
SearchLineLoop        equ $-SearchLineData+TSA-2
       cpi
       push af
       dec hl
       call IncHLMem1
       pop af
       jr z,MatchFound
       jp pe,SearchLineLoop
     inc hl
MatchFound:
     push af
     in a,(6)
     ld d,a
     pop af
     ld a,(AppPage)
     out (6),a
     ld a,d
     pop de
     ret
LoadInstaller:
;Inputs:
;     A is the flash page the installer is located on
;     HL points to the installer
     push hl
     ld ix,InstallerData
     call LoadTSA
     pop hl
     ld (InstallerLoc),hl
     jp TSA

InstallerData:
     .dw InstallerEnd-InstallerData-2
     in a,(6)
     push af
     ld a,(TempWord4+1)
     out (6),a
     .db $CD
InstallerLoc        equ $-InstallerData+TSA-2
     .dw 0
     pop af
     out (6),a
     ret
InstallerEnd:
ReadArcData:
     .dw ReadArcEnd-ReadArcData-2
     or a
     jr nz,$+5
       ldir
       ret
     push af \ in a,(6)
     ld (PageBackUp),a
     pop af
     out (6),a
ArcReadLoop        equ $-ReadArcData+TSA-2
     dec hl
     call IncHLmem1
     ldi
     jp pe,ArcReadLoop
     in a,(6)
     push af
     ld a,(PageBackUp)
     out (6),a
     pop af
     ret
ReadArcEnd:



RamCode:
RamLoc   equ 9872h
IncHLMem1       equ $-RamCode+RamLoc
;                   speed    1 page         total
;
     inc l         ;    4    4*16384        65536
     ret nz        ;11| 5    64*5+16320*11  179840
     inc h         ;    4    4*64           256
     ret po        ;11| 5    11*63+5        698
     ld h,a
     in a,(6)      ;   11    11             11
     inc a         ;    4    4              4
     out (6),a     ;   11    11             11
     ld a,h
     ld h,40h      ;    7    7              7
     ret           ;   10    10             10
GetStatsArcCode equ $-RamCode+RamLoc
     out (6),a
     ld c,(hl)
     inc hl
     ld b,a
     ld a,h
     add a,a
     or l
     jr nz,$+8
       inc b
       ld h,40h
       ld a,b
       out (6),a
     ld a,b
     ld b,(hl)
     inc hl
     push bc
     in a,(6)
     ld c,a
     ld a,(AppPage)
     out (6),a
     ld a,c
     pop bc
     ret
RamCodeEnd:
;==================================================================
;FileSyst Routines
;==================================================================
funcOPEN:
;passes:
;     (TempWord1) points to the type byte
;     (TempWord2) points to the var data
;     (TempWord3) is the size of the var
;     (TempWord4) is the flash page the var is on
;     (iy+33) bit 6 is set if it is an OS var
     push hl           ;just a dummy push
     ld hl,(ArgLoc)
     ld bc,-9
     add hl,bc
     rst 20h
     rst 18h
     ld hl,9652h
     rst 20h
     rst 18h           ;save the name of the currently executing program
     ld hl,(965Dh)
     ld de,(965Bh)
     or a
     sbc hl,de
     push hl           ;offset into the currently executing program
     ld a,(8A11h)
     ld b,a
     ld a,(89F8h)
     ld c,a
     push bc           ;flags
     ld hl,(SPSave)
     push hl
     xor a
     ld (8445h),a      ;reset keyboard
     call funcOpenCode
     bcall(4018h)
     xor a
     ld (8445h),a      ;reset keyboard
     pop hl
     ld (SPSave),hl
     call SetFileSystHook
     call LoadWD
     pop bc
     ld a,b
     ld (8A11h),a
     ld a,c
     ld (89F8h),a
;Restore currently executing program
     bcall(4390h)       ;PopRealO1
     ld de,9652h
     ld hl,OP1
     ld bc,9
     ldir                ;start restoring the executing program
     bcall(_ChkFindSym)
     jp c,HardExit       ;It doesn't exist
     ex de,hl
     ld c,(hl)
     inc hl
     ld b,(hl)
     add hl,bc
     ld (965Fh),hl
     inc hl
     sbc hl,bc
     ld (965Bh),hl
     pop de              ;offset
     add hl,de
     ld (965Dh),hl
;Restore the string
     bcall(4390h)      ;PopRealO1
     bcall(_ChkFindSym)
     jp c,HardExit
     ex de,hl
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ex (sp),hl
     ld (StrSize),hl
     ex de,hl
     sbc hl,de
     pop de
     add hl,de
     ld (StrLoc),hl
     ret nc
     jp HardExit      ;means the temp string was destroyed
funcOpenCode:
     call OpenFolder
     push af
     push hl
     push de
     call SaveWD
     pop de
     ld hl,14
     add hl,sp
     ld sp,hl
     ld hl,(StrSize)
     push hl
     ld hl,-12
     add hl,sp
     ld sp,hl
     pop hl
     pop af
     ret c

     push de
     call ShortcutLoop
     set 6,(iy+33)
     jr nc,$+9
       call OSVarInfo
       res 6,(iy+33)
     call GetStatsArc
     ld (TempWord1),de
     ld (TempWord2),hl
     ld (TempWord3),bc
     ld (TempWord4),a
     pop hl
     xor a
     call FindField
     jp nc,OpenFile
;     Here FileSyst handles the code
;     This is useful BASIC and nostub assembly programs
;     (TempWord1) points to the type byte
;     (TempWord2) points to the var data
;     (TempWord3) is the size of the var
;     (TempWord4) is the flash page the var is on
;     (iy+33) bit 6 is set if it is an OS var
     bit 6,(iy+33)
     jp z,OpenOSVar
ExecFileSystVar:
     ld hl,(TempWord3)
     ld a,h
     or l
     ret z
     bcall(4324h)      ;create a tempstring
     inc de
     inc de
     ld a,(TempWord4)
     ld bc,(TempWord3)
     ld hl,(TempWord2)
     push de
     push bc     
     call ReadArc
     jp FileSystCommand-4
OpenOSVar:
     ld a,(TempWord4)
     ld hl,(TempWord2)
     ld bc,11
     ld de,8478h        ;OP1
     call ReadArc
;No we can look at the header
;Later, if I want to be useful, I can add checks for special headers
     ld hl,8478h
     ld bc,(TempWord3)
     ld a,$BB
     cp (hl)
     jr nz,OpenOSBASIC
     inc l
     ld a,(hl)
     cp 6Dh
     jr nz,OpenOSBASIC
     ld hl,(TempWord2)
     inc hl \ dec bc
     cpi \ ret po      ;no data
     ld a,h \ cp 80h
     jr nz,PageIncremented
       ld a,l
       or a
       jr z,$+5
       dec a
       jr nz,PageIncremented
       ld a,(TempWord4)
       inc a
       ld (TempWord4),a
       res 7,h
       set 6,h
PageIncremented:
;Gotta load the program OS style. Some assembly progs rely on that
     ld (TempAddr),hl
     ld h,b
     ld l,c
     bcall(42FDh) ;EnoughMem
     ret c                ;not enough mem
     ex de,hl
     ld de,9D95h
     push hl
     bcall(_InsertMem)    ;we already took care of HL=0
     pop bc
     ld hl,(TempAddr)
     ld a,(TempWord4)
     ld de,9D95h
     push bc
     call ReadArc
     call 9D95h
     pop de
     ld hl,9D95h
     bcall(_DelMem)
     ret
OpenOSBASIC:
     ld a,(TempWord4)
     ld hl,(TempWord1)
     ld de,(TempWord2)
RunBASIC:
;Inputs:
;     A is the flash page the data is on
;     BC is the prog size, if it is in flash
;     DE is the location of the var data, if in flash
;     HL points to the VAT entry
     push hl
     or a
     jr z,ProgIsInRAM
     push de
     push af
     push bc
     ld hl,TempName2
     rst 20h
     bcall(_ChkFindSym)
     jr c,$+5
     bcall(4FC6h)     ;DelVarArc
     pop hl
     ld a,16h
     bcall(4E70h)     ;createvar
     inc de
     inc de
     pop af
     ld (TempWord1),hl
     pop hl
     call ReadArc
     ld hl,(TempWord1)
     ex (sp),hl
ProgIsInRAM:
     pop hl
     call VATProgName
     set 1,(iy+8)
     bcall(4A9Bh)        ;ParseInp
     ret
OpenFile:
;Inputs:
;     HL points to Field 0 size bytes
     inc hl
     inc hl
     ex de,hl
     ld hl,FALUT
     call FindAssoc
SearchInternal:
     jr nz,SearchExternal
     push de
     push bc
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     ld hl,FAFail
     push hl
     ex de,hl
     jp (hl)
FAFail:
     pop hl
     pop de
     jp z,SetAns1       ;FileHandled
     call BadKeyWord+1  ;we need to point to the next keyword.
     jr SearchInternal
SearchExternal:
CouldNotOpen:
     bcall(41BCh)       ;_OP2Set0
     ret
FindAssoc:
;Input:
;     HL points to a keyword in the FA LUT
;     DE points to a keyword in Field 0
;Outputs:
;     nz returned if no match
;     z returned if match
;     HL points to the address of the call
;     DE points to the keyword that matched
;     BC points to the current progress in the LUT
;Notes:
;     If you call this again:
;       BC -> HL
;       DE -> DE
     ld a,(de)
     or a
     jr nz,$+4      ;means no match found at all
       inc a
       ret
     push hl
KeyWordMatchLoop:
     ld a,(hl)
     or a
     jr z,BadKeyWord       
     push de
KeyWordMatchLoop1:
     ld a,(de)
     or a
     jr z,KeyWordMatch
     inc de
     cp (hl)
     ld a,(hl)
     inc hl
     jr nz,NotAKWMatch-1
     or a
     jr nz,KeyWordMatchLoop1
     dec hl
NotAKWMatch:
     pop de
     ld a,(hl) \ or a \ inc hl \ jr nz,$-3
     inc hl
     inc hl
     jr KeyWordMatchLoop
BadKeyWord:
     pop hl
     ld a,(de) \ or a \ inc de \ jr nz,$-3
     jr FindAssoc
KeyWordMatch:
     cp (hl)
     jr nz,NotAKWMatch
     inc hl
     pop de
     pop bc
     ret
FindInputFA:
     call OpenFolder
     jr c,AssocDNE+1
     push de
     call InputStrInfo
     ld (TempAddr),hl
     pop hl
     ld a,d
     or e
     jr z,AssocDNE+1
     xor a
     push de
     call FindField
     ld (TempWord1),de
     call c,MakeFieldSub
     pop bc 
FindFA:
;Inputs:
;     BC is the size of the search string
;     HL points to the size bytes of field 0
;Outputs:
;     z flag set if a match was found, else nz
;     BC is preserved
;     DE points to the beginning of the string in the header, if found
;     HL is preserved
;     A is 0 if there was a match, else it is 1.
     push hl
     ld e,(hl)
     inc hl
     ld d,(hl)
     add hl,de
     ld (hl),0
     sbc hl,de
     inc hl
     ex de,hl
     ld hl,(TempAddr)   ;FA string
AssocLoop:
;BC = Size of FA string
;HL = Loc of FA string
;DE points to start of the FA field data
     ld a,(de)
     or a
     jr z,AssocDNE
     push bc
     push hl
     push de
AssocLoop0:
     ld a,(de)
     inc de
     cpi
     jr nz,AssocNoMatch
     jp pe,AssocLoop0
     ld a,(de)
     or a
     jr nz,AssocNoMatch
     pop de
     pop hl
     pop bc
     pop hl
     ret
AssocNoMatch:
     pop hl
     pop hl
     pop bc
     ld a,(de)
     inc de
     or a
     jr nz,$-3
     jr AssocLoop
AssocDNE:
     pop hl
     or 1
     ret
GetInfo:
;Input:
;     HL points to the size bytes
;Output:
;     HL points to size bytes
;     DE points to the info byte
;     A is the info byte
     push hl
     dec hl
     ld d,(hl)
     dec hl
     ld e,(hl)
     scf
     sbc hl,de
     ld a,(hl)
     ex de,hl
     pop hl
     ret
LoadWD:
     set 5,(iy+33)
     ld hl,WDStr
     rst 20h
     call FindSym
     jr nc,WDInit
     ld a,31
     ld hl,129
     bcall(_CreateVar)
     push de
     inc de
     call SetMemF+1        ;hackadaysickal
     pop de
WDInit:
     inc de
     inc de
     ld bc,129
     ld hl,DirNest
     ex de,hl
     ldir
     ret
FindField:
;Input:
;     HL points to the file header
;     A is the field number
;Outputs:
;     c flag set if the field was not found, z flag set if there are no fields
;     HL points to the specific field size bytes
;     DE points to the field data
     cp a
     push af
     call SkipToInfo
     inc hl
     ld d,h
     ld e,l
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld a,b
     or c
     jr nz,$+5
       pop af
       scf
       ret
     dec bc
     dec bc
     pop af
FindFieldLoop:
     cpi
     ret z
     dec bc
     dec bc
     push bc
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     add hl,bc
     ex (sp),hl
     sbc hl,bc
     ex (sp),hl
     pop bc
     jr nz,FindFieldLoop
     inc c
     scf
     ret
openION:
     call Exist_DCS7
     jp z,OpenWithDCS
     call Exist_DCS6
     jp z,OpenWithDCS
 ret
     call Exist_MOS
     jp z,OpenAsmProg
     call Exist_ION
     jp z,OpenAsmProg
     call Exist_NoShell
     jp z,OpenAsmProg
     ret
openMOS:
     call Exist_DCS7
     jp z,OpenWithDCS
     call Exist_DCS6
     jp z,OpenWithDCS
 ret
     call Exist_MOS
     jp z,OpenAsmProg
     call Exist_NoShell
     jp z,OpenAsmProg
     ret
openDCS6:
     call Exist_DCS6
     jp z,OpenWithDCS
openDCS7:
     call Exist_DCS7
     jp z,OpenWithDCS
     ret
openBatLib:
     call Exist_BatLib
     ret nz
     ld a,(TempWord4+1)
     ld hl,4084h
     ld de,8478h
     ld bc,2
     call ReadArc
     ld hl,(8478h)
     dec hl
     ld (9BACh),hl
     ld (9BAEh),a
     set 1,(iy+36h)
     ld bc,(TempWord3)
     jp OpenOSBASIC
openC3:
     call Exist_DCS7
     jp z,OpenWithDCS
     call Exist_Celtic3
     ret nz
RunC3Prog:
;Install Celtic3 hook, then run prog
;be sure to back up the parser hook
     ld a,(TempWord4)
     ld hl,(TempWord1)
     ld de,(TempWord2)
     ld bc,(TempWord3)
     push af
     push bc
     push de
     push hl
     ld hl,4083h
     call LoadInstaller
     pop hl
     pop de
     pop bc
     pop af
     jp RunBASIC
openxLIB:
     call Exist_DCS7
     jp z,OpenWithDCS
     call Exist_Celtic3
     jp z,RunC3Prog
     call Exist_xLIB
     ret nz
;  Install xLIB hook, then run prog
;  Asked tr1p1ea, he said to just load it directly
     ld a,(TempWord4+1)
     ld (9BAEh),a
     ld hl,4111h
     ld (9BACh),hl
     set 1,(iy+36h)
     ld bc,(TempWord3)
     jp OpenOSBASIC
openDCSB:
     call Exist_DCS7
     ret nz
OpenWithDCS:
     bit 6,(iy+33) \ ret nz
     ld de,9D95h
     ld hl,DCSprgmEnd-DCSprgmStart
     bcall(_InsertMem)
     ld hl,ExecDCSprgm
     ld de,9D95h
     ld bc,DCSprgmEnd-DCSprgmStart
     push bc
     push de
     ldir
     call 9D95h
     pop hl
     pop de
     bcall(_DelMem)
     xor a
     ret
openOmniCalc:
     call Exist_Omnicalc
     ret nz
     ld a,(TempWord4+1)
     ld (9BAEh),a
;Omnicalc 1.26
     ld hl,4D10h              ;location of Omnicalc hook
     ld bc,1
     ld de,8478h
     call ReadArc
     dec e
     ld a,(de)
     cp 83h
     jr z,$+5
;Omnicalc 1.26 MP
     ld hl,4D19h
InstallOmni:
     dec l
     ld (9BACh),hl
     set 1,(iy+36h)
     ld bc,(TempWord3)
     jp OpenOSBASIC
     ret
openFileSyst:
    ;Just run the prog with whatever method 
    or 1
    ret
openAXEF:
    call Exist_Axe
    ret nz
OpenAxeFusion:
     ret
openGrammer:
     call Exist_Grammer
     ret nz
openGramFile:
     ld de,9D95h
     ld hl,GRAMprgmEnd-GRAMprgmStart
     bcall(_InsertMem)
     ld hl,ExecGRAMprgm
     ld de,9D95h
     ld bc,GRAMprgmEnd-GRAMprgmStart
     push bc
     push de
     ldir
     ld hl,(TempWord1)
     call VATProgName
     call 9D95h
     pop hl
     pop de
     bcall(_DelMem)
     xor a
     ret
VATProgName:
     ld bc,-6
     add hl,bc
     ld de,8478h
     ld a,5
     ld (de),a
     inc e
     ld b,(hl)
       dec hl
       ld a,(hl)
       ld (de),a
       inc e
       djnz $-4
     xor a
     ld (de),a
     ret
Exist_ION:
     ld hl,IONName
     jr Exist_App
Exist_MOS:
     ld hl,MOSName
     jr Exist_App
Exist_DCS7:
     ld hl,DCS7Name
     jr Exist_App
Exist_DCS6:
     ld hl,DCS6Name
     jr Exist_App
Exist_NoShell:
     ld hl,NoshellName
     jr Exist_App
Exist_BatLib:
     ld hl,BatLibName
     jr Exist_App
Exist_Celtic3:
     ld hl,Celtic3Name
     jr Exist_App
Exist_xLIB:
     ld hl,xLIBName
     jr Exist_App
Exist_Omnicalc:
     ld hl,OmnicalcName
     jr Exist_App
Exist_Axe:
     ld hl,AxeName
     jr Exist_App
Exist_Grammer:
     ld hl,GrammerName
Exist_App:
     rst 20h
     bcall(_FindApp)
     ld (TempWord4+1),a
     jr nc,$+5
       or 1
       ret
     xor a
     ret
OpenAsmProg:
     ret
ErrBadVarName:
     ld hl,BadVarNameStr1
Error:
     ld de,appErr1       ;984Dh
     ld bc,12
     ldir
     ld a,43+128         ;AppErr1 (custom error)
     bcall(_JError)
ErrBadName:
     ld hl,BadNameStr1
     jr Error
ErrLargeNest:
     ld hl,LargeNestStr1
     jr Error
ErrVarNotFound:
     ld hl,VarNotFoundStr1
     jr Error
ErrNotAFolder:
     ld hl,NotAFolderStr1
     jr Error
ErrNotAFile:
     ld hl,NotAFileStr1
     jr Error
ErrFatal
     ld hl,FatalStr1
     jr Error
GetTokenisedSize:
;Input:
;     BC is the size of the ASCII string
;     HL points to the ASCII string
;Output:
;     BC is how large the tokenised version will be
;     HL points to the byte after the ASCII string

     push bc
     jr GETDNameLoop1
AddNameSizeToBC:
     inc hl \ dec de
     push bc
     ld c,(hl)
     ld b,0
     ex (sp),hl
     add hl,bc
     ex (sp),hl
     inc hl \ dec de
GETDNameLoop1:
     call Is_Lowercase
     jr nc,$+5
       ex (sp),hl
       inc hl
       ex (sp),hl
     dec de
     cpi
     jp pe,GETDNameLoop1
;HL points to icon
     pop bc
     ret
OpenShortcut:
;Input:
;     HL points to the size bytes of the shortcut
;Outputs:
;     Same as OpenFolder
     ex de,hl
     ld hl,(StrLoc)
     ld (SCSaveStrLoc),hl
     ld hl,(StrSize)
     push hl
     ex de,hl       ;HL points to the size bytes
     jr $+4
     pop af
OpenShortcutLoop:
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
     ld (StrSize),bc
     ld (StrLoc),hl
     call OpenFolder
     push af
     push de
     ex de,hl
     call SkipToInfo
     ld a,(hl)
     ex de,hl
     pop de
     bit 3,a
     jr nz,OpenShortcutLoop-1
     pop af
     ld bc,(SCSaveStrLoc)
     ld (StrLoc),bc
     pop bc     
     ret
ResizeFile:
;Inputs:
;     DE is the new size
;     HL points to the size bytes
;Outputs:
;     BC is the difference in the old versus new size
;     DE points to the data of the var
     ld c,(hl)
     ld (hl),e
     inc hl
     ld b,(hl)
     ld (hl),d
     inc hl
     ex de,hl
     or a
     sbc hl,bc
;HL is positive if we insert mem, negative otherwise
;DE points to where to insert/delete
     ld b,h
     ld c,l
     jp InsertMem
SkipToInfo:
     inc hl
     ld c,(hl)
     inc c
     ld b,0
     add hl,bc
     ld a,(hl)
     inc hl
     inc a
     ret nz
     ld c,21h
     add hl,bc
     ret
CopyCurPath:
     ld a,(DirNest)
     ld (NestDepth),a
     inc a
     add a,a
     ld b,0
     ld c,a
     ld a,(hl)
     ld hl,DirBuf
     ld de,FileBuf
     ldir
     ret
CurFold:
     call CopyCurPath
     ex de,hl
     dec hl
     ld d,(hl)
     dec hl
     ld e,(hl)
     ex de,hl
     call FindFileStart
Is_FSStart:
     ld a,(de)
     cp 1Fh
     ret z
     ld bc,(FSLoc)
     or a
     sbc hl,bc
     add hl,bc
     ret nz
     scf
     ret     
OpenFolder:
;Return z if it is a folder, nz if not
;Return c if it is the main folder, nc otherwise
     ld hl,(StrLoc)
     ld a,(hl)
     cp 3Eh
     jr z,LoadDir
     cp 29h
     jr z,LoadDir
     cp 3Ah
     jr z,LoadDir
     cp 11h
     jr z,CurFold
       dec hl
       ld (StrLoc),hl
       ld hl,(StrSize)
       inc hl
       ld (StrSize),hl
       xor a
       ld (NestDepth),a
       ld h,a
       ld l,a
       ld (FileBuf),hl
       jr BeginToOpen
LoadDir:
     call CopyCurPath
BeginToOpen:
     ld hl,FileBuf
     ld a,(NestDepth)
     add a,a
     add a,l
     ld l,a
     jr nc,$+3
     inc h
     ld e,(hl)
     inc hl
     ld d,(hl)
     ld hl,(FSLoc)
     add hl,de
OpenFolderLoop:
;If type is 17h, read as a group
;     call GetInfo
;     rlca
;     jr nc,ReadFolder
ReadGroup:
;       
ReadFolder:
     ld c,(hl)
     inc hl
     ld b,(hl)
     inc hl
;HL now points to the current folder data
;BC is the size of the folder
;Now I need to try to search the folder for a string of vars
     ld (TempWord1),hl     ;Is this needed anymore?
     ld (TempWord2),bc
     call GetArgPtr      ;return 1F if it was a folder, 00 if the args are finished, -1 if the folder jumped back
     cp -2
     jr nz,$+6
       push de
       push hl
       jr NestAdjusted
     cp 1Fh
     ret nz
     push de
     push hl
     ld a,(NestDepth)
     ld bc,(FSLoc)
     sbc hl,bc
       ex de,hl
       ld hl,Filebuf
       inc a
       cp 64
       jp z,ErrLargeNest
       ld (NestDepth),a
       add a,a
       add a,l
       ld l,a
       jr nc,$+3
       inc h
       ld (hl),e
       inc hl
       ld (hl),d
;       ex de,hl      ;is this needed?
NestAdjusted:
       ld hl,(StrSize)
       ld a,h
       or l
       jr z,ExitOFLoop
       ld hl,(StrLoc)
       ld a,(hl)
       cp 2Bh
       jr z,ExitOFLoop
       cp 11h
ExitOFLoop:
       pop hl
       pop de
     jr nz,OpenFolderLoop
     jp Is_FSStart
GetArgPtr:
;     Returns DE points to Type byte
;     HL points to size bytes

     ld hl,(StrLoc)
     ld bc,(StrSize)
     ld a,3Ah
     cp (hl)
     jr nz,ForwardFold
       inc hl
       cp (hl)
       jr nz,ForwardFold-1
       dec bc
       ld de,(NestDepth)
BackFoldLoop:
       cpi
       jr nz,$+12
       jp po,$+10
         inc e
         dec e
         jr z,$+3
         dec e
         jr BackFoldLoop
       ld a,e
       ld (NestDepth),a
       inc bc
       dec hl
       ld (StrLoc),hl
       ld (StrSize),bc
       ld hl,FileBuf
       add a,a
       add a,l
       ld l,a
       ld e,(hl)
       inc hl
       ld d,(hl)
       ex de,hl
       call FindFileStart
       ld a,-2
       ret
     dec hl
ForwardFold:
     push hl
     ld de,0
     jr adfjhg
ArgPtrLoop:
       ld a,(hl)
       cp 3Eh           ;:
       jr z,EndOfArg
       cp 29h           ;space (for the start of a var name)
       jr z,EndOfArg
       cp 2Bh           ;,
       jr z,EndOfArg
       cp 11h           ;)
       jr z,EndOfArg
adfjhg:
       ldi
       jp pe,ArgPtrLoop
EndOfArg:
     ld (StrSize),bc
     ld (StrLoc),hl
     ld c,e
     ld b,d
     pop hl
;HL points to the arg
;BC is the size of the arg
SearchFile:
;Inputs:
;     (TempWord1) points to current folder data
;     (TempWord2) points to the folder size
;     HL points to the arg
;     BC is the size of the arg
     ld a,(hl)
     call ConvToType
     cpi
     jp po,ErrBadName
     ld b,a
SearchFileName:
;Inputs:
;     (TempWord1) points to current folder data
;     (TempWord2) points to the folder size
;     HL points to name
;     C is the size of the name
;     B is the type
     push hl
     ld (NameLoc),hl
     pop ix               ;points to the arg
     ld hl,(TempWord1)    ;points to current folder data
     ld de,(TempWord2)    ;folder size
;  ld a,d
;  or e
;  jr z,CreateVar
SearchVarLoop:
     ld a,b
     cp -1
     jr z,CheckName
     cp (hl)
     jr nz,NextVar
Checkname:
     inc hl \ dec de
     ld a,(hl)
     cp c
     jr nz,NextVar+2
     push ix
     push bc
     push hl
     inc hl
     ld b,0
CompareVNameLoop:
       ld a,(ix)
       cp (hl)
       jr nz,NotGood
       inc ix
       cpi
       jp pe,CompareVNameLoop
;VarFound:
     pop de
     dec de
     ld a,(hl)
     inc hl       ;skip icon
     inc a
     jr nz,$+6
       ld bc,33
       add hl,bc
     inc hl
     ld c,(hl) \ inc hl
     ld b,(hl) \ inc hl
     add hl,bc
;HL points to the size bytes
;DE points to the start of the var entry

     pop af     ;Need A to be the type, anyways
     pop bc     ;just a wasted POP
     ret
NotGood:
     pop hl
     pop bc
     pop ix
     jr Nextvar+2
NextVar:
     inc hl \ dec de
     push bc
     ld b,0
     ld c,(hl)
     inc hl
     add hl,bc
     scf
     ex de,hl
     sbc hl,bc
     ex de,hl

     ld a,(hl)
     inc hl \ dec de      ;skip icon
     inc a
     jr nz,$+10
       ld bc,33
       add hl,bc
       ex de,hl
       sbc hl,bc
       ex de,hl
     inc hl \ dec de
     call SkipData
     call SkipData
     pop bc
     jr z,FS_CreateVar
     jp p,SearchVarLoop
FS_CreateVar:
;B is the var type
;IX points to the name
;C is the size of the var name
;When this gets edited, the size of every folder in the folder buffer needs to be updated
;This will be daunting.
;Let's not die.
;The size of the file will be:
;     8 bytes+name length
     inc b
     jr z,$+3
     dec b
     ld a,8
     add a,c
     ld e,a
     ld d,0
     push de
     push bc
     ld hl,(TempWord1)
     ex de,hl
     bcall(_InsertMem)     ;Try to use call InsertMem
     ld hl,(NameLoc)
     pop bc
     ex de,hl
     ld (hl),b
     inc hl
     ld (hl),c
     inc hl
     xor a
     ld b,a
     ex de,hl
;     sbc hl,bc
     ldir
     ex de,hl
     ld (hl),a      ;icon (set to default)
     inc hl
     ld (hl),a      ;info
     inc hl
     ld (hl),a      ;size of field
     inc hl
     ld (hl),a      ;size of field
     inc hl
     pop bc
     push  hl
     ld (hl),a      ;size of data
     inc hl
     ld (hl),a      ;size of data
;var added, now we must update a bazillion pointers
     call Adjust
;HL points to the size bytes
;DE points to the start of the var entry
     ld de,(TempWord1)
     ld a,(de)
     pop hl
     ret
AdjustHeaderSize:
;HL points to where the data is inserted or removed
;BC is the number of bytes to insert (or negative if it is to remove).
;     preserves all registers
     push af
     push bc
     push de
     push hl
     ex de,hl
     ld h,b
     ld l,c
     ld a,b
     or c
     call nz,InsertMem
     pop hl
     pop de
     pop bc
     pop af
     ret
FindFileStart:
;HL is the offset into the file system
     ld de,(FSLoc)
     add hl,de
     push hl
     dec hl
     ld b,(hl)
     dec hl
     ld c,(hl)
     dec hl
     or a
     sbc hl,bc ;now HL points to the icon
     ld a,(hl)
     dec hl
     inc a
     jr nz,$+8
       ld a,l
       sub 33
       jr nc,$+3
       dec h
     dec hl
     ld bc,256
     ld a,-1
       inc a
       cpd
       jp po,$+5
       jr nz,$-6
     ex de,hl
     pop hl
     ret
InsertMem:
;Inputs:
;     HL is the number of bytes to insert
;     DE is the location
;Output:
;     BC is the number of bytes that were added
     ld a,h
     or l
     ret z
     push hl
     push de
     bit 7,h
     jr nz,DelMem
     bcall(_InsertMem)
     jr Adjust-2
DelMem:
     xor a \ sub l \ ld l,a
     sbc a,a \ sub h \ ld h,a
     ex de,hl
     bcall(_DelMem)
     pop hl
     pop bc
Adjust:
;HL is where the data got inserted
;BC is the number of bytes inserted
     ld de,(FSLoc)
     scf
     sbc hl,de
     ex de,hl
     ld ix,DirBuf
     ld a,(DirNest)
     inc a              ;DE needs to be 1 if at beginning
;DE is the offset into the file system where the change was made
;BC is the number of bytes
AdjustLoop:
     ex de,hl
     ld e,(ix)
     inc ix
     ld d,(ix)
     inc ix
     ex de,hl
     or a
     sbc hl,de
     jr c,$+12
       add hl,de
       add hl,bc
       ex de,hl
       ld (ix-2),e
       ld (ix-1),d
       ex de,hl
     dec a
     jr nz,AdjustLoop
FileBufAdjust:
;BC is the number of bytes that were added
;A is 0
;HL points to the end of the filebuf
;DE is the offset into the file system where the bytes were inserted
     ld a,(NestDepth)
     inc a
     ld hl,FileBuf
AdjustPtrLoop:
     ld e,(hl)
     inc hl
     ld d,(hl)
     inc hl
     push af
     push hl
       ex de,hl  ;hl points to the size bytes
       push bc
       ld bc,(FSLoc)
       add hl,bc
       pop bc
       ld e,(hl)
       inc hl
       ld d,(hl)
       ex de,hl
       add hl,bc
       ex de,hl
       ld (hl),d
       dec hl
       ld (hl),e
     pop hl
     pop af
     dec a
     jr nz,AdjustPtrLoop
     ret
SkipData:
     ld c,(hl)
     inc hl \ dec de
     ld b,(hl)
     inc hl
     add hl,bc
     scf
     ex de,hl
     sbc hl,bc
     ex de,hl
     ret
ConvToType:
;BC is the size of the arg
;HL points to the arg
;A is the type
;    Returns -1 if it is unknown
     cp 71h
     jr z,$+18
     cp 3Ah
     jr z,$+14
     cp 2Bh
     jr z,$+10
     cp 10h
     jr z,$+6
     cp 3Eh
     jr nz,$+5
       ld a,1Fh
       ret
;     cp 29h
;     jr z,$+5
       ld a,-1
       ret
;     cpi
;     jp po,ErrBadName
;     ld a,(hl)
;     and 1Fh
;     ret
OSVarName:
     ld de,OP1
     ld hl,(StrPtr)
     ld bc,(StrSize)
     ld a,(hl)
     cp 5Fh
     jr nz,$+11
       ld a,5
       cpi
       jp po,ErrBadVarName
       jr CopyVarName
     cp 5Ch
     jr nz,$+6
       ld a,2
       jr CopyVarName
     cp 5Dh
     jr nz,$+6
       ld a,1
       jr CopyvarName
     cp $EB
     jr nz,$+15
       ld a,1
       ld (de),a
       inc e
       ld a,5Dh
       cpi
       jp po,ErrBadVarName
       jr CopyVarName
     cp 5Eh
     jr nz,$+6
       ld a,3
       jr CopyVarName
     cp 60h
     jr nz,$+6
       ld a,7
       jr CopyVarName
     cp 61h
     jr nz,$+6
       ld a,8
       jr CopyVarName
     cp $AA
     jr nz,$+6
       ld a,4
       jr CopyVarName
     and 1Fh
     cpi
     jp po,ErrBadVarName
CopyVarName:
     ld (de),a
     inc e
CopyVarNameLoop:
     ld a,(hl)
     cp 2Bh            ;comma
     jr z,EndOfName
     cp 11h            ;)
     jr z,EndOfName
     ldi
     jp pe,CopyVarNameLoop
EndOfName:
     xor a
     ld (de),a
     cpi
     ld (StrSize),bc
     ld (StrLoc),hl
     ld hl,OP1
     ex de,hl
     scf
     sbc hl,de
     push hl
     call FindVar
     ex (sp),hl
     ld c,l
     pop hl
     ret
ConvRStr8:
;Modify so that it updates StrLoc and StrSize
;Inputs:
;     HL points to the string
;Outputs:
;     HL points to the ending byte
;     e is the 8-bit value
;Speed: 63n+32
;
;
     ld bc,(StrSize)
     ld a,b
     or c
     ld e,0
     ret z
     ld hl,(StrLoc)
ConvRStr8Loop:
     cpi
     jp po,$+10
     ld a,(hl)        ;7      7
     sub 30h
     cp 10            ;7     14
     jr c,$+10
       ld (StrSize),bc
       ld (StrLoc),hl
       ret
     ld d,a
     ld a,e
     add a,a          ;4     37
     add a,a          ;4     41
     add a,e          ;4     45
     add a,a          ;4     49
     add a,d
     ld e,a           ;4     53
     jp ConvRStr8Loop ;10    63
LoadHexAtDE:
;Returns c flag set if it was a hex digit and BC>0
     ld a,(de)
     cp 3Ah
     jr c,$+4
     sub 7
     sub 30h
     ccf
     ret nc
     cp 10h
     ret nc
     rld
     ex de,hl
     cpi
     ex de,hl
     ret pe
     or a
     ret
InputStrInfo:
;Returns DE=Size, HL=Loc
     ld hl,(StrLoc)
     ld bc,(StrSize)
     ld de,0
     cpi
     ret po
     call Is_EndOfStr
     jr nz,$+4
       cpi
     push hl
InputStrInfoLoop:
     call Is_EndOfStr
     jr z,$+8
     inc de
     cpi
     jp pe,InputStrInfoLoop
     cp 3Fh
     jr z,$+4
       cpi
     ld (StrLoc),hl
     ld (StrSize),bc
     pop hl
;     inc hl
     ret
Is_EndOfStr:
     ld a,(hl)
     cp 2Ah     ;"
     ret z
     cp $AE     ;'
     ret z
     cp 3Fh     ;newline
     ret z
     cp 4
     ret
Is_EndOfArg:
     ld a,(hl)
     cp 29h
     ret z
     cp 2Bh
     ret z
     cp 3Fh
     ret z
     cp 11h
     ret
MakeFieldSub:
;c flag is 1 to create a field with 1 byte, else 0
        push af
        ld c,5
        jr z,$+4
        ld c,3
        ld a,b
        adc a,c
        ld l,a
        ld h,b
        inc de
        inc de
        push de
        call InsertMem
        pop hl
        pop af
        ld (hl),a
        inc hl
        sbc a,a
        neg
        ld (hl),a
        inc hl
        ld (hl),0
        dec hl
        push hl
        call ResizeFields
        pop hl
        ret
ExecDCSprgm:
DCSprgmStart:
     ld hl,(TempWord1)
     in a,(6)
     push af
     ld a,(TempWord4+1)
     out (6),a
AppCall     equ $-DCSprgmStart+9D96h
     call 4131h    ;runprog
     pop af
     out (6),a
     ret
DCSprgmEnd:

ExecGRAMprgm:
GRAMprgmStart:
     in a,(6)
     push af
     ld a,(TempWord4+1)
     out (6),a
     call 4086h    ;_CompatCall
     bcall(4153h)  ;OP1ToOP5
     call z,4089h  ;_SelectedProg
     pop af
     out (6),a
     ret
GRAMprgmEnd:

Icons:
Icon1:
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
     .db %11111111,%11111111
Icon2:
     .db %11111111,%11111111
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %10000000,%00000001
     .db %11111111,%11111111
FALUT:
     .db "ION",0  \ .dw openION
     .db "MOS",0  \ .dw openMOS
     .db "DCS",0  \ .dw openDCS7
     .db "BAT",0  \ .dw openBatLib
     .db "BATB",0 \ .dw openBatLib
     .db "C3",0   \ .dw openC3
     .db "XLIB",0 \ .dw openxLIB
     .db "DCS6",0 \ .dw openDCS6
     .db "DCS7",0 \ .dw openDCS7
     .db "DCSB",0 \ .dw openDCSB
     .db "OMNI",0 \ .dw openOmniCalc
     .db "SYS",0  \ .dw openFileSyst
     .db "AXEF",0 \ .dw openAXEF
     .db "GRAM",0 \ .dw openGrammer

     .db 0
FS_LUT:
     addfunc(3,"AFA",funcAFA)
     addfunc(5,"BASIC",funcBASIC)
     addfunc(2,"CD",funcCD)
     addfunc(2,"CF",funcCF)
     addfunc(3,"CFT",funcCFT)
     addfunc(2,"CI",funcCI)
     addfunc(2,"CN",funcCN)
     addfunc(4,"COMP",funcCOMP)
     addfunc(4,"COPY",funcCOPY)
     addfunc(2,"CP",funcCOPY)
     addfunc(3,"DEL",funcDEL)
     addfunc(4,"FDEL",funcFDEL)
     addfunc(4,"GETD",funcGETD)
     addfunc(4,"GETF",funcGETF)
     addfunc(5,"GICON",funcGICON)
     addfunc(4,"HIDE",funcHIDE)
     addfunc(4,"LOCK",funcLOCK)
     addfunc(4,"MOVE",funcMOVE)
     addfunc(2,"MV",funcMOVE)
     addfunc(4,"OPEN",funcOPEN)
     addfunc(3,"PWD",funcPWD)
     addfunc(3,"RFA",funcRFA)
     addfunc(4,"SCUT",funcSCUT)
     addfunc(4,"VPTR",funcVPTR)
     .db 0
MOSName:
     .db 14h,"MirageOS"
GrammerName:
     .db 14h,"Grammer "
xLIBName:
     .db 14h,"xLIB    "
Celtic3Name:
     .db 14h,"Celtic 3"
AxeName:
     .db 14h,"Axe     "
DCS7Name:
     .db 14h,"DoorsCS7"
DCS6Name:
     .db 14h,"DoorsCS6"
OmnicalcName:
     .db 14h,"Omnicalc"
NoshellName:
     .db 14h,"Noshell "
IONName:
     .db 14h,"ION     "
BatLibName:
     .db 14h,"BatLib  "
FatalStr1:
     .db "Fatal",0
NotAFileStr1:
     .db "Not A File",0
NotAFolderStr1:
     .db "Not A Folder"
VarNotFoundStr1:
     .db "VarNotFound",0
TempName2:
     .db 16h,"FileT",0    ;mignon
LargeNestStr1:
     .db "Large Nest"
WDStr:
     .db 0,"WD",0
FuncNotFoundStr1:
     .db "FuncNotFound"
BadVarNameStr1:
     .db "Bad Var Name"
BadNameStr1:
     .db "Bad Name"
FSVar:
     .db 0       ;Normally, this is the var type (31 in our case). We don't need it, though, so I am using zero for an optimisation.
     .db "FS"    ;This is the actual name. It must be two bytes in this case.
     .db 0       ;End the var name
;==================================================================

FontVarName     equ $-RamCode+RamLoc
;     .db 0,0,0,0,"         "
;RamCodeEnd:   ;58 bytes

StrErrBadNumber:
     .db 3Ah,"BAD",29h,"NUMBER"
StrErrBadInput:
     .db 3Ah,"BAD",29h,"INPUT"
StrErrBadName:
     .db 3Ah,"BAD",29h,"NAME"
StrErrNoData:
     .db 3Ah,"NO",29h,"DATA"
StrErrTooBig:
     .db 3Ah,"TOO",29h,"BIG"
StrErrArch:
     .db 3Ah,"ARCH"
StrErrBadX:
     .db 3Ah,"BAD",29h,"X"
StrErrBadY:
     .db 3Ah,"BAD",29h,"Y"
StrErrWidth:
     .db 3Ah,"WIDTH"
StrErrHeight:
     .db 3Ah,"HEIGHT"
StrErrEOF:
     .db 3Ah,"EOF"
StrErrMEM:
     .db 3Ah,"MEM"
StrErrDNE:
     .db 3Ah,"DNE"
SelectProgStr:
     .db "Select Program:<>",0
Str8Space:
     .db 20h,20h,20h,20h,20h,20h,20h,20h
BatVarName:
     .db 0
     .dw BatVar
     .db 0
TempName:
     .db 16h,"Temp",0
Version:
     .db "0000002"

.echo "Bytes Left:",8000h-$,":"